package com.steerinfo.ems.emspaihoursumtab1org.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.Date;

@ApiModel(value="动力小时准点值表")
public class EmsPAiHourSumTab1Org implements IBasePO<String> {
    @ApiModelProperty(value="",required=true)
    private String clock;

    @ApiModelProperty(value="",required=false)
    private Date insertTime;

    /**
     * 一焦化焦炉煤气发生（出厂）流量累积量(yww)(TAG1,FLOAT,126)
     */
    @ApiModelProperty(value="一焦化焦炉煤气发生（出厂）流量累积量(yww)",required=false)
    private Double tag1;

    /**
     * 一焦化焦炉煤气管式炉使用累积量(yww)(TAG2,FLOAT,126)
     */
    @ApiModelProperty(value="一焦化焦炉煤气管式炉使用累积量(yww)",required=false)
    private Double tag2;

    /**
     * 一焦化焦炉煤气放散塔发散流量累积量(yww)(TAG3,FLOAT,126)
     */
    @ApiModelProperty(value="一焦化焦炉煤气放散塔发散流量累积量(yww)",required=false)
    private Double tag3;

    /**
     * 一焦化焦炉煤气1#焦炉焦炉煤气使用（主管）流量累积量(yww)(TAG4,FLOAT,126)
     */
    @ApiModelProperty(value="一焦化焦炉煤气1#焦炉焦炉煤气使用（主管）流量累积量(yww)",required=false)
    private Double tag4;

    /**
     * 一焦化焦炉煤气2#焦炉焦炉煤气使用（主管）流量累积量(yww)(TAG5,FLOAT,126)
     */
    @ApiModelProperty(value="一焦化焦炉煤气2#焦炉焦炉煤气使用（主管）流量累积量(yww)",required=false)
    private Double tag5;

    /**
     * 一焦化1#焦炉机侧高炉煤气使用流量累积量(yww)(TAG6,FLOAT,126)
     */
    @ApiModelProperty(value="一焦化1#焦炉机侧高炉煤气使用流量累积量(yww)",required=false)
    private Double tag6;

    /**
     * 一焦化1#焦炉焦侧高炉煤气使用流量累积量(yww)(TAG7,FLOAT,126)
     */
    @ApiModelProperty(value="一焦化1#焦炉焦侧高炉煤气使用流量累积量(yww)",required=false)
    private Double tag7;

    /**
     * 一焦化2#焦炉机侧高炉煤气使用流量累积量(yww)(TAG8,FLOAT,126)
     */
    @ApiModelProperty(value="一焦化2#焦炉机侧高炉煤气使用流量累积量(yww)",required=false)
    private Double tag8;

    /**
     * 一焦化2#焦炉焦侧高炉煤气使用流量累积量(yww)(TAG9,FLOAT,126)
     */
    @ApiModelProperty(value="一焦化2#焦炉焦侧高炉煤气使用流量累积量(yww)",required=false)
    private Double tag9;

    /**
     * 一焦化化产锅炉管式炉蒸汽使用流量累积量(yww)(TAG10,FLOAT,126)
     */
    @ApiModelProperty(value="一焦化化产锅炉管式炉蒸汽使用流量累积量(yww)",required=false)
    private Double tag10;

    /**
     * 二焦化化产锅炉蒸汽送出流量准点值(yww)(TAG11,FLOAT,126)
     */
    @ApiModelProperty(value="二焦化化产锅炉蒸汽送出流量准点值(yww)",required=false)
    private Double tag11;

    /**
     * 二焦化化产1#锅炉蒸汽发生流量准点值(yww)(TAG12,FLOAT,126)
     */
    @ApiModelProperty(value="二焦化化产1#锅炉蒸汽发生流量准点值(yww)",required=false)
    private Double tag12;

    /**
     * 二焦化化产2#锅炉蒸汽发生流量准点值(yww)(TAG13,FLOAT,126)
     */
    @ApiModelProperty(value="二焦化化产2#锅炉蒸汽发生流量准点值(yww)",required=false)
    private Double tag13;

    /**
     * 二焦化化产1#锅炉焦炉煤气使用流量1准点值(yww)(TAG14,FLOAT,126)
     */
    @ApiModelProperty(value="二焦化化产1#锅炉焦炉煤气使用流量1准点值(yww)",required=false)
    private Double tag14;

    /**
     * 二焦化化产1#锅炉焦炉煤气使用流量2准点值(yww)(TAG15,FLOAT,126)
     */
    @ApiModelProperty(value="二焦化化产1#锅炉焦炉煤气使用流量2准点值(yww)",required=false)
    private Double tag15;

    /**
     * 二焦化化产2#锅炉焦炉煤气使用流量1准点值(yww)(TAG16,FLOAT,126)
     */
    @ApiModelProperty(value="二焦化化产2#锅炉焦炉煤气使用流量1准点值(yww)",required=false)
    private Double tag16;

    /**
     * 二焦化化产2#锅炉焦炉煤气使用流量2准点值(yww)(TAG17,FLOAT,126)
     */
    @ApiModelProperty(value="二焦化化产2#锅炉焦炉煤气使用流量2准点值(yww)",required=false)
    private Double tag17;

    /**
     * 二焦化焦炉煤气发生流量准点值(yww)(TAG18,FLOAT,126)
     */
    @ApiModelProperty(value="二焦化焦炉煤气发生流量准点值(yww)",required=false)
    private Double tag18;

    /**
     * 二焦化焦炉煤气管式炉使用准点值(yww)(TAG19,FLOAT,126)
     */
    @ApiModelProperty(value="二焦化焦炉煤气管式炉使用准点值(yww)",required=false)
    private Double tag19;

    /**
     * 二焦化1#焦炉机侧高炉煤气使用流量准点值(yww)(TAG20,FLOAT,126)
     */
    @ApiModelProperty(value="二焦化1#焦炉机侧高炉煤气使用流量准点值(yww)",required=false)
    private Double tag20;

    /**
     * 二焦化1#焦炉焦侧高炉煤气使用流量准点值(yww)(TAG21,FLOAT,126)
     */
    @ApiModelProperty(value="二焦化1#焦炉焦侧高炉煤气使用流量准点值(yww)",required=false)
    private Double tag21;

    /**
     * 二焦化2#焦炉机侧高炉煤气使用流量准点值(yww)(TAG22,FLOAT,126)
     */
    @ApiModelProperty(value="二焦化2#焦炉机侧高炉煤气使用流量准点值(yww)",required=false)
    private Double tag22;

    /**
     * 二焦化2#焦炉焦侧高炉煤气使用流量准点值(yww)(TAG23,FLOAT,126)
     */
    @ApiModelProperty(value="二焦化2#焦炉焦侧高炉煤气使用流量准点值(yww)",required=false)
    private Double tag23;

    /**
     * 一体系1#竖炉高炉煤气使用流量(yww)(TAG24,FLOAT,126)
     */
    @ApiModelProperty(value="一体系1#竖炉高炉煤气使用流量(yww)",required=false)
    private Double tag24;

    /**
     * 一炼铁烧结高压蒸汽产量(yww)(TAG25,FLOAT,126)
     */
    @ApiModelProperty(value="一炼铁烧结高压蒸汽产量(yww)",required=false)
    private Double tag25;

    /**
     * 二焦化氮气使用流量(yww)(TAG26,FLOAT,126)
     */
    @ApiModelProperty(value="二焦化氮气使用流量(yww)",required=false)
    private Double tag26;

    /**
     * 1#炉工艺氮气流量(yww)(TAG27,FLOAT,126)
     */
    @ApiModelProperty(value="1#炉工艺氮气流量(yww)",required=false)
    private Double tag27;

    /**
     * 2#炉工艺氮气流量(yww)(TAG28,FLOAT,126)
     */
    @ApiModelProperty(value="2#炉工艺氮气流量(yww)",required=false)
    private Double tag28;

    /**
     * 1#烧结点火炉高炉煤气用量(yww)(TAG29,FLOAT,126)
     */
    @ApiModelProperty(value="1#烧结点火炉高炉煤气用量(yww)",required=false)
    private Double tag29;

    /**
     * 1#烧结预热炉高炉煤气用量(yww)(TAG30,FLOAT,126)
     */
    @ApiModelProperty(value="1#烧结预热炉高炉煤气用量(yww)",required=false)
    private Double tag30;

    /**
     * 2#烧结点火炉高炉煤气用量(yww)(TAG31,FLOAT,126)
     */
    @ApiModelProperty(value="2#烧结点火炉高炉煤气用量(yww)",required=false)
    private Double tag31;

    /**
     * 2#烧结预热炉高炉煤气用量(yww)(TAG32,FLOAT,126)
     */
    @ApiModelProperty(value="2#烧结预热炉高炉煤气用量(yww)",required=false)
    private Double tag32;

    /**
     * 一炼钢焦炉煤气转炉总用量(LRL)(TAG33,FLOAT,126)
     */
    @ApiModelProperty(value="一炼钢焦炉煤气转炉总用量(LRL)",required=false)
    private Double tag33;

    /**
     * 一炼钢连铸焦炉煤气总管累计量(LRL)(TAG34,FLOAT,126)
     */
    @ApiModelProperty(value="一炼钢连铸焦炉煤气总管累计量(LRL)",required=false)
    private Double tag34;

    /**
     * 一炼钢氧气总用量(LRL)(TAG35,FLOAT,126)
     */
    @ApiModelProperty(value="一炼钢氧气总用量(LRL)",required=false)
    private Double tag35;

    /**
     * 一炼钢高压氮气总用量(LRL)(TAG36,FLOAT,126)
     */
    @ApiModelProperty(value="一炼钢高压氮气总用量(LRL)",required=false)
    private Double tag36;

    /**
     * 一炼钢低压氮气总用量(LRL)(TAG37,FLOAT,126)
     */
    @ApiModelProperty(value="一炼钢低压氮气总用量(LRL)",required=false)
    private Double tag37;

    /**
     * 一炼钢氩气总用量(LRL)(TAG38,FLOAT,126)
     */
    @ApiModelProperty(value="一炼钢氩气总用量(LRL)",required=false)
    private Double tag38;

    /**
     * 炼钢1#转炉煤气回收量(LRL)(TAG39,FLOAT,126)
     */
    @ApiModelProperty(value="炼钢1#转炉煤气回收量(LRL)",required=false)
    private Double tag39;

    /**
     * 炼钢2#转炉煤气回收量(LRL)(TAG40,FLOAT,126)
     */
    @ApiModelProperty(value="炼钢2#转炉煤气回收量(LRL)",required=false)
    private Double tag40;

    /**
     * 一炼钢高炉煤气转炉总用量(LRL)(TAG41,FLOAT,126)
     */
    @ApiModelProperty(value="一炼钢高炉煤气转炉总用量(LRL)",required=false)
    private Double tag41;

    /**
     * 一炼钢高炉煤气连铸总用量(LRL)(TAG42,FLOAT,126)
     */
    @ApiModelProperty(value="一炼钢高炉煤气连铸总用量(LRL)",required=false)
    private Double tag42;

    /**
     * 二炼铁一号球团高炉煤气南用量(yww)(TAG43,FLOAT,126)
     */
    @ApiModelProperty(value="二炼铁一号球团高炉煤气南用量(yww)",required=false)
    private Double tag43;

    /**
     * 二炼铁一号球团高炉煤气北用量(yww)(TAG44,FLOAT,126)
     */
    @ApiModelProperty(value="二炼铁一号球团高炉煤气北用量(yww)",required=false)
    private Double tag44;

    /**
     * 二炼铁二号球团高炉煤气南用量(yww)(TAG45,FLOAT,126)
     */
    @ApiModelProperty(value="二炼铁二号球团高炉煤气南用量(yww)",required=false)
    private Double tag45;

    /**
     * 二炼铁二号球团高炉煤气北用量(yww)(TAG46,FLOAT,126)
     */
    @ApiModelProperty(value="二炼铁二号球团高炉煤气北用量(yww)",required=false)
    private Double tag46;

    /**
     * 一制氧氧气发生量(wjt)(TAG47,FLOAT,126)
     */
    @ApiModelProperty(value="一制氧氧气发生量(wjt)",required=false)
    private Double tag47;

    /**
     * 一制氧氮气发生量(wjt)(TAG48,FLOAT,126)
     */
    @ApiModelProperty(value="一制氧氮气发生量(wjt)",required=false)
    private Double tag48;

    /**
     * 一制氧氩气发生量(wjt)(TAG49,FLOAT,126)
     */
    @ApiModelProperty(value="一制氧氩气发生量(wjt)",required=false)
    private Double tag49;

    /**
     * 二制氧氧气发生量(wjt)(TAG50,FLOAT,126)
     */
    @ApiModelProperty(value="二制氧氧气发生量(wjt)",required=false)
    private Double tag50;

    /**
     * 二制氧氮气发生量(wjt)(TAG51,FLOAT,126)
     */
    @ApiModelProperty(value="二制氧氮气发生量(wjt)",required=false)
    private Double tag51;

    /**
     * 二制氧氩气发生量(wjt)(TAG52,FLOAT,126)
     */
    @ApiModelProperty(value="二制氧氩气发生量(wjt)",required=false)
    private Double tag52;

    @ApiModelProperty(value="",required=false)
    private Double tag53;

    /**
     * 一炼铁高炉焦炉煤气使用量(yww)(TAG54,FLOAT,126)
     */
    @ApiModelProperty(value="一炼铁高炉焦炉煤气使用量(yww)",required=false)
    private Double tag54;

    /**
     * 一炼铁球团烘干煤气使用量(yww)(TAG55,FLOAT,126)
     */
    @ApiModelProperty(value="一炼铁球团烘干煤气使用量(yww)",required=false)
    private Double tag55;

    /**
     * 一焦锅炉房焦气使用量(yww)(TAG56,FLOAT,126)
     */
    @ApiModelProperty(value="一焦锅炉房焦气使用量(yww)",required=false)
    private Double tag56;

    /**
     * 二焦化1#2#炉焦气放散(yww)(TAG57,FLOAT,126)
     */
    @ApiModelProperty(value="二焦化1#2#炉焦气放散(yww)",required=false)
    private Double tag57;

    /**
     * 二炼钢一号转炉氧气使用流量累积量(LRL)(TAG58,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢一号转炉氧气使用流量累积量(LRL)",required=false)
    private Double tag58;

    @ApiModelProperty(value="",required=false)
    private Double tag59;

    /**
     * 二炼钢一号转炉氮气使用流量累积量(LRL)(TAG60,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢一号转炉氮气使用流量累积量(LRL)",required=false)
    private Double tag60;

    /**
     * 二炼钢二号转炉氧气使用流量累积量(LRL)(TAG61,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢二号转炉氧气使用流量累积量(LRL)",required=false)
    private Double tag61;

    /**
     * 二炼钢二号转炉氮气使用流量累积量(LRL)(TAG62,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢二号转炉氮气使用流量累积量(LRL)",required=false)
    private Double tag62;

    /**
     * 二炼钢三号转炉氧气使用流量累积量(LRL)(TAG63,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢三号转炉氧气使用流量累积量(LRL)",required=false)
    private Double tag63;

    /**
     * 二炼钢三号转炉氮气使用流量累积量(LRL)(TAG64,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢三号转炉氮气使用流量累积量(LRL)",required=false)
    private Double tag64;

    /**
     * 二炼钢高炉煤气转炉总用量(LRL)(TAG65,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢高炉煤气转炉总用量(LRL)",required=false)
    private Double tag65;

    /**
     * 二炼钢高炉煤气连铸总用量(LRL)(TAG66,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢高炉煤气连铸总用量(LRL)",required=false)
    private Double tag66;

    /**
     * 二炼钢焦炉煤气转炉总用量(LRL)(TAG67,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢焦炉煤气转炉总用量(LRL)",required=false)
    private Double tag67;

    /**
     * 二炼钢焦炉煤气连铸总用量(LRL)(TAG68,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢焦炉煤气连铸总用量(LRL)",required=false)
    private Double tag68;

    /**
     * 二炼钢氧气总用量(LRL)(TAG69,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢氧气总用量(LRL)",required=false)
    private Double tag69;

    /**
     * 二炼钢高压氮气总用量(LRL)(TAG70,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢高压氮气总用量(LRL)",required=false)
    private Double tag70;

    /**
     * 二炼钢低压氮气总用量(LRL)(TAG71,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢低压氮气总用量(LRL)",required=false)
    private Double tag71;

    /**
     * 二炼钢氩气总用量(LRL)(TAG72,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢氩气总用量(LRL)",required=false)
    private Double tag72;

    /**
     * 二炼钢新水总用量(LRL)(TAG73,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢新水总用量(LRL)",required=false)
    private Double tag73;

    /**
     * 炼钢1#转炉煤气回收(LRL)(TAG74,FLOAT,126)
     */
    @ApiModelProperty(value="炼钢1#转炉煤气回收(LRL)",required=false)
    private Double tag74;

    /**
     * 炼钢2#转炉煤气回收(LRL)(TAG75,FLOAT,126)
     */
    @ApiModelProperty(value="炼钢2#转炉煤气回收(LRL)",required=false)
    private Double tag75;

    /**
     * 一轧钢混合站高炉煤气当日使用量(lrl)(TAG76,FLOAT,126)
     */
    @ApiModelProperty(value="一轧钢混合站高炉煤气当日使用量(lrl)",required=false)
    private Double tag76;

    /**
     * 一轧钢混合站高炉煤气当月使用量(lrl)(TAG77,FLOAT,126)
     */
    @ApiModelProperty(value="一轧钢混合站高炉煤气当月使用量(lrl)",required=false)
    private Double tag77;

    /**
     * 一轧钢混合站焦炉煤气当月使用量(lrl)(TAG78,FLOAT,126)
     */
    @ApiModelProperty(value="一轧钢混合站焦炉煤气当月使用量(lrl)",required=false)
    private Double tag78;

    /**
     * 一轧钢混合站焦炉煤气当日使用量(lrl)(TAG79,FLOAT,126)
     */
    @ApiModelProperty(value="一轧钢混合站焦炉煤气当日使用量(lrl)",required=false)
    private Double tag79;

    /**
     * 一轧钢混合站混合煤气当日使用量(lrl)(TAG80,FLOAT,126)
     */
    @ApiModelProperty(value="一轧钢混合站混合煤气当日使用量(lrl)",required=false)
    private Double tag80;

    /**
     * 一轧钢混合站混合煤气当月使用量(lrl)(TAG81,FLOAT,126)
     */
    @ApiModelProperty(value="一轧钢混合站混合煤气当月使用量(lrl)",required=false)
    private Double tag81;

    /**
     * 一焦化氮气使用流量1(yww)(TAG82,FLOAT,126)
     */
    @ApiModelProperty(value="一焦化氮气使用流量1(yww)",required=false)
    private Double tag82;

    /**
     * 一焦化氮气使用流量2(yww)(TAG83,FLOAT,126)
     */
    @ApiModelProperty(value="一焦化氮气使用流量2(yww)",required=false)
    private Double tag83;

    /**
     * 一焦化氮气使用流量3(yww)(TAG84,FLOAT,126)
     */
    @ApiModelProperty(value="一焦化氮气使用流量3(yww)",required=false)
    private Double tag84;

    /**
     * 一焦化氮气使用流量4(yww)(TAG85,FLOAT,126)
     */
    @ApiModelProperty(value="一焦化氮气使用流量4(yww)",required=false)
    private Double tag85;

    /**
     * 一焦化氮气使用流量5(yww)(TAG86,FLOAT,126)
     */
    @ApiModelProperty(value="一焦化氮气使用流量5(yww)",required=false)
    private Double tag86;

    /**
     * 辅料一车间3#回转高炉煤气窑使用量(wjt)(TAG87,FLOAT,126)
     */
    @ApiModelProperty(value="辅料一车间3#回转高炉煤气窑使用量(wjt)",required=false)
    private Double tag87;

    /**
     * 辅料一车间3#回转窑焦炉煤气使用量(wjt)(TAG88,FLOAT,126)
     */
    @ApiModelProperty(value="辅料一车间3#回转窑焦炉煤气使用量(wjt)",required=false)
    private Double tag88;

    /**
     * 辅料一车间4#回转窑焦炉煤气使用量(wjt)(TAG89,FLOAT,126)
     */
    @ApiModelProperty(value="辅料一车间4#回转窑焦炉煤气使用量(wjt)",required=false)
    private Double tag89;

    /**
     * 辅料一车间4#回转转炉煤气窑使用量(wjt)(TAG90,FLOAT,126)
     */
    @ApiModelProperty(value="辅料一车间4#回转转炉煤气窑使用量(wjt)",required=false)
    private Double tag90;

    /**
     * 辅料一车间回转窑焦炉煤气总使用量(wjt)(TAG91,FLOAT,126)
     */
    @ApiModelProperty(value="辅料一车间回转窑焦炉煤气总使用量(wjt)",required=false)
    private Double tag91;

    /**
     * 辅料一车间回转窑转炉煤气总使用量(wjt)(TAG92,FLOAT,126)
     */
    @ApiModelProperty(value="辅料一车间回转窑转炉煤气总使用量(wjt)",required=false)
    private Double tag92;

    /**
     * 辅料一车间回转窑高炉煤气总使用量(wjt)(TAG93,FLOAT,126)
     */
    @ApiModelProperty(value="辅料一车间回转窑高炉煤气总使用量(wjt)",required=false)
    private Double tag93;

    /**
     * 辅料一车间氮气使用量(wjt)(TAG94,FLOAT,126)
     */
    @ApiModelProperty(value="辅料一车间氮气使用量(wjt)",required=false)
    private Double tag94;

    /**
     * 辅料一车间回转窑空气总量(wjt)(TAG95,FLOAT,126)
     */
    @ApiModelProperty(value="辅料一车间回转窑空气总量(wjt)",required=false)
    private Double tag95;

    /**
     * 辅料一车间回转窑蒸汽总量(wjt)(TAG96,FLOAT,126)
     */
    @ApiModelProperty(value="辅料一车间回转窑蒸汽总量(wjt)",required=false)
    private Double tag96;

    /**
     * 辅料二车间1#回转窑高炉煤气使用量(wjt)(TAG97,FLOAT,126)
     */
    @ApiModelProperty(value="辅料二车间1#回转窑高炉煤气使用量(wjt)",required=false)
    private Double tag97;

    /**
     * 辅料二车间2#回转窑高炉煤气使用量(wjt)(TAG98,FLOAT,126)
     */
    @ApiModelProperty(value="辅料二车间2#回转窑高炉煤气使用量(wjt)",required=false)
    private Double tag98;

    /**
     * 辅料二车间1#回转窑焦炉煤气使用量(wjt)(TAG99,FLOAT,126)
     */
    @ApiModelProperty(value="辅料二车间1#回转窑焦炉煤气使用量(wjt)",required=false)
    private Double tag99;

    /**
     * 辅料二车间2#回转窑焦炉煤气使用量(wjt)(TAG100,FLOAT,126)
     */
    @ApiModelProperty(value="辅料二车间2#回转窑焦炉煤气使用量(wjt)",required=false)
    private Double tag100;

    /**
     * 辅料二车间1#回转窑压缩空气使用量(wjt)(TAG101,FLOAT,126)
     */
    @ApiModelProperty(value="辅料二车间1#回转窑压缩空气使用量(wjt)",required=false)
    private Double tag101;

    /**
     * 辅料二车间2#回转窑压缩空气使用量(wjt)(TAG102,FLOAT,126)
     */
    @ApiModelProperty(value="辅料二车间2#回转窑压缩空气使用量(wjt)",required=false)
    private Double tag102;

    /**
     * 辅料二车间氮气使用量(wjt)(TAG103,FLOAT,126)
     */
    @ApiModelProperty(value="辅料二车间氮气使用量(wjt)",required=false)
    private Double tag103;

    /**
     * 超细粉高炉煤气使用量(wjt)(TAG104,FLOAT,126)
     */
    @ApiModelProperty(value="超细粉高炉煤气使用量(wjt)",required=false)
    private Double tag104;

    /**
     * 超细粉氮气使用量(wjt)(TAG105,FLOAT,126)
     */
    @ApiModelProperty(value="超细粉氮气使用量(wjt)",required=false)
    private Double tag105;

    /**
     * 80MW高炉煤气使用量(wjt)(TAG106,FLOAT,126)
     */
    @ApiModelProperty(value="80MW高炉煤气使用量(wjt)",required=false)
    private Double tag106;

    /**
     * 80MW焦炉煤气使用量(wjt)(TAG107,FLOAT,126)
     */
    @ApiModelProperty(value="80MW焦炉煤气使用量(wjt)",required=false)
    private Double tag107;

    /**
     * 一轧钢总管混合站混合煤气发生量(LRL)(TAG108,FLOAT,126)
     */
    @ApiModelProperty(value="一轧钢总管混合站混合煤气发生量(LRL)",required=false)
    private Double tag108;

    /**
     * 一轧钢总管氧气使用量(LRL)(TAG109,FLOAT,126)
     */
    @ApiModelProperty(value="一轧钢总管氧气使用量(LRL)",required=false)
    private Double tag109;

    /**
     * 一轧钢总管氮气使用量(LRL)(TAG110,FLOAT,126)
     */
    @ApiModelProperty(value="一轧钢总管氮气使用量(LRL)",required=false)
    private Double tag110;

    /**
     * 一轧钢总管新水使用量(LRL)(TAG111,FLOAT,126)
     */
    @ApiModelProperty(value="一轧钢总管新水使用量(LRL)",required=false)
    private Double tag111;

    /**
     * 一轧钢混合站新水使用量(LRL)(TAG112,FLOAT,126)
     */
    @ApiModelProperty(value="一轧钢混合站新水使用量(LRL)",required=false)
    private Double tag112;

    /**
     * 一轧钢混合站复用水使用量(LRL)(TAG113,FLOAT,126)
     */
    @ApiModelProperty(value="一轧钢混合站复用水使用量(LRL)",required=false)
    private Double tag113;

    /**
     * 一轧钢棒材蒸气发生量(LRL)(TAG114,FLOAT,126)
     */
    @ApiModelProperty(value="一轧钢棒材蒸气发生量(LRL)",required=false)
    private Double tag114;

    /**
     * 一轧钢一高线蒸气发生量(LRL)(TAG115,FLOAT,126)
     */
    @ApiModelProperty(value="一轧钢一高线蒸气发生量(LRL)",required=false)
    private Double tag115;

    /**
     * 一轧钢三高线蒸气发生量(LRL)(TAG116,FLOAT,126)
     */
    @ApiModelProperty(value="一轧钢三高线蒸气发生量(LRL)",required=false)
    private Double tag116;

    /**
     * 一炼铁热风炉高炉煤气用量(yww)(TAG117,FLOAT,126)
     */
    @ApiModelProperty(value="一炼铁热风炉高炉煤气用量(yww)",required=false)
    private Double tag117;

    /**
     * 一炼铁高炉喷煤用量(yww)(TAG118,FLOAT,126)
     */
    @ApiModelProperty(value="一炼铁高炉喷煤用量(yww)",required=false)
    private Double tag118;

    /**
     * 一炼铁高炉氧气用量(yww)(TAG119,FLOAT,126)
     */
    @ApiModelProperty(value="一炼铁高炉氧气用量(yww)",required=false)
    private Double tag119;

    /**
     * 一炼铁热风炉N2用量(yww)(TAG120,FLOAT,126)
     */
    @ApiModelProperty(value="一炼铁热风炉N2用量(yww)",required=false)
    private Double tag120;

    /**
     * 一炼铁布袋除尘氮气用量(yww)(TAG121,FLOAT,126)
     */
    @ApiModelProperty(value="一炼铁布袋除尘氮气用量(yww)",required=false)
    private Double tag121;

    /**
     * 一炼铁喷煤氮气用量(yww)(TAG122,FLOAT,126)
     */
    @ApiModelProperty(value="一炼铁喷煤氮气用量(yww)",required=false)
    private Double tag122;

    /**
     * 一炼铁高炉煤气发用量(yww)(TAG123,FLOAT,126)
     */
    @ApiModelProperty(value="一炼铁高炉煤气发用量(yww)",required=false)
    private Double tag123;

    /**
     * 一炼铁烧结点火炉高炉煤气用量(yww)(TAG124,FLOAT,126)
     */
    @ApiModelProperty(value="一炼铁烧结点火炉高炉煤气用量(yww)",required=false)
    private Double tag124;

    /**
     * 一炼铁烧结氮气用量(yww)(TAG125,FLOAT,126)
     */
    @ApiModelProperty(value="一炼铁烧结氮气用量(yww)",required=false)
    private Double tag125;

    /**
     * 一炼铁烧结蒸汽产量(yww)(TAG126,FLOAT,126)
     */
    @ApiModelProperty(value="一炼铁烧结蒸汽产量(yww)",required=false)
    private Double tag126;

    /**
     * 一炼铁球团高炉煤气用量(yww)(TAG127,FLOAT,126)
     */
    @ApiModelProperty(value="一炼铁球团高炉煤气用量(yww)",required=false)
    private Double tag127;

    /**
     * 一炼铁球团蒸汽产量(yww)(TAG128,FLOAT,126)
     */
    @ApiModelProperty(value="一炼铁球团蒸汽产量(yww)",required=false)
    private Double tag128;

    /**
     * 二体系高炉1#高炉热风炉焦气用量(yww)(TAG129,FLOAT,126)
     */
    @ApiModelProperty(value="二体系高炉1#高炉热风炉焦气用量(yww)",required=false)
    private Double tag129;

    /**
     * 二体系高炉2#高炉热风炉焦气用量(yww)(TAG130,FLOAT,126)
     */
    @ApiModelProperty(value="二体系高炉2#高炉热风炉焦气用量(yww)",required=false)
    private Double tag130;

    /**
     * 二体系高炉1#高炉热风炉1高炉煤气用量(yww)(TAG131,FLOAT,126)
     */
    @ApiModelProperty(value="二体系高炉1#高炉热风炉1高炉煤气用量(yww)",required=false)
    private Double tag131;

    /**
     * 二炼铁一号氮气用量(yww)(TAG132,FLOAT,126)
     */
    @ApiModelProperty(value="二炼铁一号氮气用量(yww)",required=false)
    private Double tag132;

    /**
     * 二炼铁二号氮气用量(yww)(TAG133,FLOAT,126)
     */
    @ApiModelProperty(value="二炼铁二号氮气用量(yww)",required=false)
    private Double tag133;

    /**
     * 二体系高炉1#高炉热风炉4高炉煤气用量(yww)(TAG134,FLOAT,126)
     */
    @ApiModelProperty(value="二体系高炉1#高炉热风炉4高炉煤气用量(yww)",required=false)
    private Double tag134;

    /**
     * 二体系高炉2#高炉热风炉1高炉煤气用量(yww)(TAG135,FLOAT,126)
     */
    @ApiModelProperty(value="二体系高炉2#高炉热风炉1高炉煤气用量(yww)",required=false)
    private Double tag135;

    /**
     * 二体系高炉2#高炉热风炉2高炉煤气用量(yww)(TAG136,FLOAT,126)
     */
    @ApiModelProperty(value="二体系高炉2#高炉热风炉2高炉煤气用量(yww)",required=false)
    private Double tag136;

    /**
     * 二体系高炉2#高炉热风炉3高炉煤气用量(yww)(TAG137,FLOAT,126)
     */
    @ApiModelProperty(value="二体系高炉2#高炉热风炉3高炉煤气用量(yww)",required=false)
    private Double tag137;

    /**
     * 二炼铁喷煤高炉煤气总用量(yww)(TAG138,FLOAT,126)
     */
    @ApiModelProperty(value="二炼铁喷煤高炉煤气总用量(yww)",required=false)
    private Double tag138;

    /**
     * 二炼铁1#高炉富氧用量(yww)(TAG139,FLOAT,126)
     */
    @ApiModelProperty(value="二炼铁1#高炉富氧用量(yww)",required=false)
    private Double tag139;

    /**
     * 二炼铁2#高炉富氧用量(yww)(TAG140,FLOAT,126)
     */
    @ApiModelProperty(value="二炼铁2#高炉富氧用量(yww)",required=false)
    private Double tag140;

    /**
     * 二体系高炉1#高炉氮气总用量(yww)(TAG141,FLOAT,126)
     */
    @ApiModelProperty(value="二体系高炉1#高炉氮气总用量(yww)",required=false)
    private Double tag141;

    /**
     * 二体系高炉2#高炉氮气总用量(yww)(TAG142,FLOAT,126)
     */
    @ApiModelProperty(value="二体系高炉2#高炉氮气总用量(yww)",required=false)
    private Double tag142;

    /**
     * 二炼铁氮气总用量(yww)(TAG143,FLOAT,126)
     */
    @ApiModelProperty(value="二炼铁氮气总用量(yww)",required=false)
    private Double tag143;

    /**
     * 1#高炉高炉煤气总产量(yww)(TAG144,FLOAT,126)
     */
    @ApiModelProperty(value="1#高炉高炉煤气总产量(yww)",required=false)
    private Double tag144;

    /**
     * 2#高炉高炉煤气总产量(yww)(TAG145,FLOAT,126)
     */
    @ApiModelProperty(value="2#高炉高炉煤气总产量(yww)",required=false)
    private Double tag145;

    /**
     * 二炼铁脱硫压缩空气使用量(yww)(TAG146,FLOAT,126)
     */
    @ApiModelProperty(value="二炼铁脱硫压缩空气使用量(yww)",required=false)
    private Double tag146;

    /**
     * 二炼铁粒化轮压缩空气使用量(yww)(TAG147,FLOAT,126)
     */
    @ApiModelProperty(value="二炼铁粒化轮压缩空气使用量(yww)",required=false)
    private Double tag147;

    /**
     * 二炼铁烧结氮气使用量(yww)(TAG148,FLOAT,126)
     */
    @ApiModelProperty(value="二炼铁烧结氮气使用量(yww)",required=false)
    private Double tag148;

    /**
     * 二体系烧结蒸汽产量(yww)(TAG149,FLOAT,126)
     */
    @ApiModelProperty(value="二体系烧结蒸汽产量(yww)",required=false)
    private Double tag149;

    /**
     * 二炼铁一号球团球团蒸汽发生量(yww)(TAG150,FLOAT,126)
     */
    @ApiModelProperty(value="二炼铁一号球团球团蒸汽发生量(yww)",required=false)
    private Double tag150;

    /**
     * 二炼铁二号球团球团蒸汽发生量(yww)(TAG151,FLOAT,126)
     */
    @ApiModelProperty(value="二炼铁二号球团球团蒸汽发生量(yww)",required=false)
    private Double tag151;

    /**
     * 二轧钢四五线混合煤气站高炉煤气累积量（四五线高炉煤气累积量）(lrl)(TAG152,FLOAT,126)
     */
    @ApiModelProperty(value="二轧钢四五线混合煤气站高炉煤气累积量（四五线高炉煤气累积量）(lrl)",required=false)
    private Double tag152;

    /**
     * 二轧钢四五线混合煤气站焦炉煤气累积量(lrl)(TAG153,FLOAT,126)
     */
    @ApiModelProperty(value="二轧钢四五线混合煤气站焦炉煤气累积量(lrl)",required=false)
    private Double tag153;

    /**
     * 二轧钢四五线氧气累积量(lrl)(TAG154,FLOAT,126)
     */
    @ApiModelProperty(value="二轧钢四五线氧气累积量(lrl)",required=false)
    private Double tag154;

    /**
     * 二轧钢四五线氮气累积量(lrl)(TAG155,FLOAT,126)
     */
    @ApiModelProperty(value="二轧钢四五线氮气累积量(lrl)",required=false)
    private Double tag155;

    /**
     * 二轧钢四五线焦炉煤气累积量(lrl)(TAG156,FLOAT,126)
     */
    @ApiModelProperty(value="二轧钢四五线焦炉煤气累积量(lrl)",required=false)
    private Double tag156;

    /**
     * 二轧钢高线焦炉煤气累积量(lrl)(TAG157,FLOAT,126)
     */
    @ApiModelProperty(value="二轧钢高线焦炉煤气累积量(lrl)",required=false)
    private Double tag157;

    /**
     * 二轧钢四五高线新水使用量(lrl)(TAG158,FLOAT,126)
     */
    @ApiModelProperty(value="二轧钢四五高线新水使用量(lrl)",required=false)
    private Double tag158;

    /**
     * 二轧钢四五高线蒸气使用量(lrl)(TAG159,FLOAT,126)
     */
    @ApiModelProperty(value="二轧钢四五高线蒸气使用量(lrl)",required=false)
    private Double tag159;

    /**
     * 二轧钢二高线氮气使用量(lrl)(TAG160,FLOAT,126)
     */
    @ApiModelProperty(value="二轧钢二高线氮气使用量(lrl)",required=false)
    private Double tag160;

    /**
     * 二轧钢二高线氧气使用量(lrl)(TAG161,FLOAT,126)
     */
    @ApiModelProperty(value="二轧钢二高线氧气使用量(lrl)",required=false)
    private Double tag161;

    /**
     * 二轧钢二高线蒸气使用量(lrl)(TAG162,FLOAT,126)
     */
    @ApiModelProperty(value="二轧钢二高线蒸气使用量(lrl)",required=false)
    private Double tag162;

    /**
     * 二轧钢二高新水使用量(lrl)(TAG163,FLOAT,126)
     */
    @ApiModelProperty(value="二轧钢二高新水使用量(lrl)",required=false)
    private Double tag163;

    /**
     * 二轧钢二高复用水使用量(lrl)(TAG164,FLOAT,126)
     */
    @ApiModelProperty(value="二轧钢二高复用水使用量(lrl)",required=false)
    private Double tag164;

    /**
     * 二轧钢二高蒸气使用量(lrl)(TAG165,FLOAT,126)
     */
    @ApiModelProperty(value="二轧钢二高蒸气使用量(lrl)",required=false)
    private Double tag165;

    /**
     * 一炼钢新水总用量(lrl)(TAG166,FLOAT,126)
     */
    @ApiModelProperty(value="一炼钢新水总用量(lrl)",required=false)
    private Double tag166;

    /**
     * 一炼钢复用水总用量(lrl)(TAG167,FLOAT,126)
     */
    @ApiModelProperty(value="一炼钢复用水总用量(lrl)",required=false)
    private Double tag167;

    /**
     * 一炼钢蒸气发生量(lrl)(TAG168,FLOAT,126)
     */
    @ApiModelProperty(value="一炼钢蒸气发生量(lrl)",required=false)
    private Double tag168;

    /**
     * 二炼钢蒸气回收量(lrl)(TAG169,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢蒸气回收量(lrl)",required=false)
    private Double tag169;

    /**
     * 二炼钢复用水使用量(lrl)(TAG170,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢复用水使用量(lrl)",required=false)
    private Double tag170;

    /**
     * 辅料二车间回转窑压缩空气使用量3(wjt)(TAG171,FLOAT,126)
     */
    @ApiModelProperty(value="辅料二车间回转窑压缩空气使用量3(wjt)",required=false)
    private Double tag171;

    /**
     * 辅料二车间蒸气使用量(wjt)(TAG172,FLOAT,126)
     */
    @ApiModelProperty(value="辅料二车间蒸气使用量(wjt)",required=false)
    private Double tag172;

    /**
     * 二炼钢氧气转炉总用量(lrl)(TAG173,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢氧气转炉总用量(lrl)",required=false)
    private Double tag173;

    /**
     * 二炼钢氧气连铸总用量(lrl)(TAG174,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢氧气连铸总用量(lrl)",required=false)
    private Double tag174;

    @ApiModelProperty(value="",required=false)
    private Double tag175;

    /**
     * 二炼钢高炉煤气总使用量(lrl)(TAG176,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢高炉煤气总使用量(lrl)",required=false)
    private Double tag176;

    /**
     * 二炼钢焦炉煤气总使用量(lrl)(TAG177,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢焦炉煤气总使用量(lrl)",required=false)
    private Double tag177;

    /**
     * 二炼钢蒸气回收量2(lrl)(TAG178,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢蒸气回收量2(lrl)",required=false)
    private Double tag178;

    /**
     * 二炼钢蒸气回收量3(lrl)(TAG179,FLOAT,126)
     */
    @ApiModelProperty(value="二炼钢蒸气回收量3(lrl)",required=false)
    private Double tag179;

    /**
     * 一制氧2W制氧机供炼钢氧气发生量(wjt)(TAG180,FLOAT,126)
     */
    @ApiModelProperty(value="一制氧2W制氧机供炼钢氧气发生量(wjt)",required=false)
    private Double tag180;

    /**
     * 一制氧2W制氧机供炼铁氧气发生量(wjt)(TAG181,FLOAT,126)
     */
    @ApiModelProperty(value="一制氧2W制氧机供炼铁氧气发生量(wjt)",required=false)
    private Double tag181;

    /**
     * 一制氧供炼铁、炼钢、二次除尘低压氮气发生量(wjt)(TAG182,FLOAT,126)
     */
    @ApiModelProperty(value="一制氧供炼铁、炼钢、二次除尘低压氮气发生量(wjt)",required=false)
    private Double tag182;

    /**
     * 一制氧供喷煤高压氮气发生量(wjt)(TAG183,FLOAT,126)
     */
    @ApiModelProperty(value="一制氧供喷煤高压氮气发生量(wjt)",required=false)
    private Double tag183;

    /**
     * 一制氧供炼钢高压氮气发生量(wjt)(TAG184,FLOAT,126)
     */
    @ApiModelProperty(value="一制氧供炼钢高压氮气发生量(wjt)",required=false)
    private Double tag184;

    /**
     * 超细粉氧气使用量(wjt)(TAG185,FLOAT,126)
     */
    @ApiModelProperty(value="超细粉氧气使用量(wjt)",required=false)
    private Double tag185;

    /**
     * 超细粉蒸气使用量(wjt)(TAG186,FLOAT,126)
     */
    @ApiModelProperty(value="超细粉蒸气使用量(wjt)",required=false)
    private Double tag186;

    /**
     * 一制氧氧气总发生量(wjt)(TAG187,FLOAT,126)
     */
    @ApiModelProperty(value="一制氧氧气总发生量(wjt)",required=false)
    private Double tag187;

    /**
     * 5#高线蒸气使用量(lrl)(TAG188,FLOAT,126)
     */
    @ApiModelProperty(value="5#高线蒸气使用量(lrl)",required=false)
    private Double tag188;

    /**
     * 二制氧氧气总发生量(结算量)(wjt)(TAG189,FLOAT,126)
     */
    @ApiModelProperty(value="二制氧氧气总发生量(结算量)(wjt)",required=false)
    private Double tag189;

    @ApiModelProperty(value="",required=false)
    private Double tag190;

    @ApiModelProperty(value="",required=false)
    private Double tag191;

    @ApiModelProperty(value="",required=false)
    private Double tag192;

    @ApiModelProperty(value="",required=false)
    private Double tag193;

    @ApiModelProperty(value="",required=false)
    private Double tag194;

    @ApiModelProperty(value="",required=false)
    private Double tag195;

    @ApiModelProperty(value="",required=false)
    private Double tag196;

    @ApiModelProperty(value="",required=false)
    private Double tag197;

    /**
     * ef区宾馆煤气使用量(TAG198,FLOAT,126)
     */
    @ApiModelProperty(value="ef区宾馆煤气使用量",required=false)
    private Double tag198;

    @ApiModelProperty(value="",required=false)
    private Double tag199;

    @ApiModelProperty(value="",required=false)
    private Double tag200;

    /**
     * 1#高炉煤气放散量(TAG201,FLOAT,126)
     */
    @ApiModelProperty(value="1#高炉煤气放散量",required=false)
    private Double tag201;

    /**
     * 2#高炉煤气放散量(TAG202,FLOAT,126)
     */
    @ApiModelProperty(value="2#高炉煤气放散量",required=false)
    private Double tag202;

    /**
     * 二焦化焦炉煤气1#焦炉焦炉煤气使用（主管）流量累积量(TAG203,FLOAT,126)
     */
    @ApiModelProperty(value="二焦化焦炉煤气1#焦炉焦炉煤气使用（主管）流量累积量",required=false)
    private Double tag203;

    /**
     * 二焦化焦炉煤气2#焦炉焦炉煤气使用（主管）流量累积量(TAG204,FLOAT,126)
     */
    @ApiModelProperty(value="二焦化焦炉煤气2#焦炉焦炉煤气使用（主管）流量累积量",required=false)
    private Double tag204;

    /**
     * 二球团烘干高炉煤气使用量(TAG205,FLOAT,126)
     */
    @ApiModelProperty(value="二球团烘干高炉煤气使用量",required=false)
    private Double tag205;

    @ApiModelProperty(value="",required=false)
    private Double tag206;

    @ApiModelProperty(value="",required=false)
    private Double tag207;

    @ApiModelProperty(value="",required=false)
    private Double tag208;

    @ApiModelProperty(value="",required=false)
    private Double tag209;

    @ApiModelProperty(value="",required=false)
    private Double tag210;

    @ApiModelProperty(value="",required=false)
    private Double tag211;

    @ApiModelProperty(value="",required=false)
    private Double tag212;

    @ApiModelProperty(value="",required=false)
    private Double tag213;

    @ApiModelProperty(value="",required=false)
    private Double tag214;

    @ApiModelProperty(value="",required=false)
    private Double tag215;

    @ApiModelProperty(value="",required=false)
    private Double tag216;

    @ApiModelProperty(value="",required=false)
    private Double tag217;

    @ApiModelProperty(value="",required=false)
    private Double tag218;

    @ApiModelProperty(value="",required=false)
    private Double tag219;

    @ApiModelProperty(value="",required=false)
    private Double tag220;

    @ApiModelProperty(value="",required=false)
    private Double tag221;

    @ApiModelProperty(value="",required=false)
    private Double tag222;

    @ApiModelProperty(value="",required=false)
    private Double tag223;

    @ApiModelProperty(value="",required=false)
    private Double tag224;

    @ApiModelProperty(value="",required=false)
    private Double tag225;

    @ApiModelProperty(value="",required=false)
    private Double tag226;

    @ApiModelProperty(value="",required=false)
    private Double tag227;

    @ApiModelProperty(value="",required=false)
    private Double tag228;

    @ApiModelProperty(value="",required=false)
    private Double tag229;

    @ApiModelProperty(value="",required=false)
    private Double tag230;

    @ApiModelProperty(value="",required=false)
    private Double tag231;

    @ApiModelProperty(value="",required=false)
    private Double tag232;

    @ApiModelProperty(value="",required=false)
    private Double tag233;

    @ApiModelProperty(value="",required=false)
    private Double tag234;

    @ApiModelProperty(value="",required=false)
    private Double tag235;

    @ApiModelProperty(value="",required=false)
    private Double tag236;

    @ApiModelProperty(value="",required=false)
    private Double tag237;

    @ApiModelProperty(value="",required=false)
    private Double tag238;

    @ApiModelProperty(value="",required=false)
    private Double tag239;

    @ApiModelProperty(value="",required=false)
    private Double tag240;

    @ApiModelProperty(value="",required=false)
    private Double tag241;

    @ApiModelProperty(value="",required=false)
    private Double tag242;

    @ApiModelProperty(value="",required=false)
    private Double tag243;

    @ApiModelProperty(value="",required=false)
    private Double tag244;

    @ApiModelProperty(value="",required=false)
    private Double tag245;

    @ApiModelProperty(value="",required=false)
    private Double tag246;

    @ApiModelProperty(value="",required=false)
    private Double tag247;

    @ApiModelProperty(value="",required=false)
    private Double tag248;

    @ApiModelProperty(value="",required=false)
    private Double tag249;

    @ApiModelProperty(value="",required=false)
    private Double tag250;

    @ApiModelProperty(value="",required=false)
    private Double tag251;

    @ApiModelProperty(value="",required=false)
    private Double tag252;

    @ApiModelProperty(value="",required=false)
    private Double tag253;

    @ApiModelProperty(value="",required=false)
    private Double tag254;

    @ApiModelProperty(value="",required=false)
    private Double tag255;

    @ApiModelProperty(value="",required=false)
    private Double tag256;

    @ApiModelProperty(value="",required=false)
    private Double tag257;

    @ApiModelProperty(value="",required=false)
    private Double tag258;

    @ApiModelProperty(value="",required=false)
    private Double tag259;

    @ApiModelProperty(value="",required=false)
    private Double tag260;

    @ApiModelProperty(value="",required=false)
    private Double tag261;

    @ApiModelProperty(value="",required=false)
    private Double tag262;

    @ApiModelProperty(value="",required=false)
    private Double tag263;

    @ApiModelProperty(value="",required=false)
    private Double tag264;

    @ApiModelProperty(value="",required=false)
    private Double tag265;

    @ApiModelProperty(value="",required=false)
    private Double tag266;

    @ApiModelProperty(value="",required=false)
    private Double tag267;

    @ApiModelProperty(value="",required=false)
    private Double tag268;

    @ApiModelProperty(value="",required=false)
    private Double tag269;

    @ApiModelProperty(value="",required=false)
    private Double tag270;

    @ApiModelProperty(value="",required=false)
    private Double tag271;

    @ApiModelProperty(value="",required=false)
    private Double tag272;

    @ApiModelProperty(value="",required=false)
    private Double tag273;

    @ApiModelProperty(value="",required=false)
    private Double tag274;

    @ApiModelProperty(value="",required=false)
    private Double tag275;

    @ApiModelProperty(value="",required=false)
    private Double tag276;

    @ApiModelProperty(value="",required=false)
    private Double tag277;

    @ApiModelProperty(value="",required=false)
    private Double tag278;

    @ApiModelProperty(value="",required=false)
    private Double tag279;

    @ApiModelProperty(value="",required=false)
    private Double tag280;

    @ApiModelProperty(value="",required=false)
    private Double tag281;

    @ApiModelProperty(value="",required=false)
    private Double tag282;

    @ApiModelProperty(value="",required=false)
    private Double tag283;

    @ApiModelProperty(value="",required=false)
    private Double tag284;

    @ApiModelProperty(value="",required=false)
    private Double tag285;

    @ApiModelProperty(value="",required=false)
    private Double tag286;

    @ApiModelProperty(value="",required=false)
    private Double tag287;

    @ApiModelProperty(value="",required=false)
    private Double tag288;

    @ApiModelProperty(value="",required=false)
    private Double tag289;

    @ApiModelProperty(value="",required=false)
    private Double tag290;

    @ApiModelProperty(value="",required=false)
    private Double tag291;

    @ApiModelProperty(value="",required=false)
    private Double tag292;

    @ApiModelProperty(value="",required=false)
    private Double tag293;

    @ApiModelProperty(value="",required=false)
    private Double tag294;

    @ApiModelProperty(value="",required=false)
    private Double tag295;

    @ApiModelProperty(value="",required=false)
    private Double tag296;

    @ApiModelProperty(value="",required=false)
    private Double tag297;

    @ApiModelProperty(value="",required=false)
    private Double tag298;

    @ApiModelProperty(value="",required=false)
    private Double tag299;

    @ApiModelProperty(value="",required=false)
    private Double tag300;
    @ApiModelProperty(value="",required=false)
    private Double tag301;

    @ApiModelProperty(value="",required=false)
    private Double tag302;

    @ApiModelProperty(value="",required=false)
    private Double tag303;

    @ApiModelProperty(value="",required=false)
    private Double tag304;

    @ApiModelProperty(value="",required=false)
    private Double tag305;

    @ApiModelProperty(value="",required=false)
    private Double tag306;

    @ApiModelProperty(value="",required=false)
    private Double tag307;

    @ApiModelProperty(value="",required=false)
    private Double tag308;

    @ApiModelProperty(value="",required=false)
    private Double tag309;

    @ApiModelProperty(value="",required=false)
    private Double tag310;

    @ApiModelProperty(value="",required=false)
    private Double tag311;

    @ApiModelProperty(value="",required=false)
    private Double tag312;

    @ApiModelProperty(value="",required=false)
    private Double tag313;

    @ApiModelProperty(value="",required=false)
    private Double tag314;

    @ApiModelProperty(value="",required=false)
    private Double tag315;

    @ApiModelProperty(value="",required=false)
    private Double tag316;

    @ApiModelProperty(value="",required=false)
    private Double tag317;

    @ApiModelProperty(value="",required=false)
    private Double tag318;

    @ApiModelProperty(value="",required=false)
    private Double tag319;

    @ApiModelProperty(value="",required=false)
    private Double tag320;

    @ApiModelProperty(value="",required=false)
    private Double tag321;

    @ApiModelProperty(value="",required=false)
    private Double tag322;

    @ApiModelProperty(value="",required=false)
    private Double tag323;

    @ApiModelProperty(value="",required=false)
    private Double tag324;

    @ApiModelProperty(value="",required=false)
    private Double tag325;

    @ApiModelProperty(value="",required=false)
    private Double tag326;

    @ApiModelProperty(value="",required=false)
    private Double tag327;

    @ApiModelProperty(value="",required=false)
    private Double tag328;

    @ApiModelProperty(value="",required=false)
    private Double tag329;

    @ApiModelProperty(value="",required=false)
    private Double tag330;

    @ApiModelProperty(value="",required=false)
    private Double tag331;

    @ApiModelProperty(value="",required=false)
    private Double tag332;

    @ApiModelProperty(value="",required=false)
    private Double tag333;

    @ApiModelProperty(value="",required=false)
    private Double tag334;

    @ApiModelProperty(value="",required=false)
    private Double tag335;

    @ApiModelProperty(value="",required=false)
    private Double tag336;

    @ApiModelProperty(value="",required=false)
    private Double tag337;

    @ApiModelProperty(value="",required=false)
    private Double tag338;

    @ApiModelProperty(value="",required=false)
    private Double tag339;

    @ApiModelProperty(value="",required=false)
    private Double tag340;

    @ApiModelProperty(value="",required=false)
    private Double tag341;

    @ApiModelProperty(value="",required=false)
    private Double tag342;

    @ApiModelProperty(value="",required=false)
    private Double tag343;

    @ApiModelProperty(value="",required=false)
    private Double tag344;

    @ApiModelProperty(value="",required=false)
    private Double tag345;

    @ApiModelProperty(value="",required=false)
    private Double tag346;

    @ApiModelProperty(value="",required=false)
    private Double tag347;

    @ApiModelProperty(value="",required=false)
    private Double tag348;

    @ApiModelProperty(value="",required=false)
    private Double tag349;

    @ApiModelProperty(value="",required=false)
    private Double tag350;

    @ApiModelProperty(value="",required=false)
    private Double tag351;

    @ApiModelProperty(value="",required=false)
    private Double tag352;

    @ApiModelProperty(value="",required=false)
    private Double tag353;

    @ApiModelProperty(value="",required=false)
    private Double tag354;

    @ApiModelProperty(value="",required=false)
    private Double tag355;

    @ApiModelProperty(value="",required=false)
    private Double tag356;

    @ApiModelProperty(value="",required=false)
    private Double tag357;

    @ApiModelProperty(value="",required=false)
    private Double tag358;

    @ApiModelProperty(value="",required=false)
    private Double tag359;

    @ApiModelProperty(value="",required=false)
    private Double tag360;

    @ApiModelProperty(value="",required=false)
    private Double tag361;

    @ApiModelProperty(value="",required=false)
    private Double tag362;

    @ApiModelProperty(value="",required=false)
    private Double tag363;

    @ApiModelProperty(value="",required=false)
    private Double tag364;

    @ApiModelProperty(value="",required=false)
    private Double tag365;

    @ApiModelProperty(value="",required=false)
    private Double tag366;

    @ApiModelProperty(value="",required=false)
    private Double tag367;

    @ApiModelProperty(value="",required=false)
    private Double tag368;

    @ApiModelProperty(value="",required=false)
    private Double tag369;

    @ApiModelProperty(value="",required=false)
    private Double tag370;

    @ApiModelProperty(value="",required=false)
    private Double tag371;

    @ApiModelProperty(value="",required=false)
    private Double tag372;

    @ApiModelProperty(value="",required=false)
    private Double tag373;

    @ApiModelProperty(value="",required=false)
    private Double tag374;

    @ApiModelProperty(value="",required=false)
    private Double tag375;

    @ApiModelProperty(value="",required=false)
    private Double tag376;

    @ApiModelProperty(value="",required=false)
    private Double tag377;

    @ApiModelProperty(value="",required=false)
    private Double tag378;

    @ApiModelProperty(value="",required=false)
    private Double tag379;

    @ApiModelProperty(value="",required=false)
    private Double tag380;

    @ApiModelProperty(value="",required=false)
    private Double tag381;

    @ApiModelProperty(value="",required=false)
    private Double tag382;

    @ApiModelProperty(value="",required=false)
    private Double tag383;

    @ApiModelProperty(value="",required=false)
    private Double tag384;

    @ApiModelProperty(value="",required=false)
    private Double tag385;

    @ApiModelProperty(value="",required=false)
    private Double tag386;

    @ApiModelProperty(value="",required=false)
    private Double tag387;

    @ApiModelProperty(value="",required=false)
    private Double tag388;

    @ApiModelProperty(value="",required=false)
    private Double tag389;

    @ApiModelProperty(value="",required=false)
    private Double tag390;

    @ApiModelProperty(value="",required=false)
    private Double tag391;

    @ApiModelProperty(value="",required=false)
    private Double tag392;

    @ApiModelProperty(value="",required=false)
    private Double tag393;

    @ApiModelProperty(value="",required=false)
    private Double tag394;

    @ApiModelProperty(value="",required=false)
    private Double tag395;

    @ApiModelProperty(value="",required=false)
    private Double tag396;

    @ApiModelProperty(value="",required=false)
    private Double tag397;

    @ApiModelProperty(value="",required=false)
    private Double tag398;

    @ApiModelProperty(value="",required=false)
    private Double tag399;

    @ApiModelProperty(value="",required=false)
    private Double tag400;


    private static final long serialVersionUID = 1L;

    @Override
    public String getId() {
        return this.clock;
    }

    @Override
    public void setId(String clock) {
        this.clock = clock == null ? null : clock.trim();
    }

    public String getClock() {
        return clock;
    }

    public void setClock(String clock) {
        this.clock = clock == null ? null : clock.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public Double getTag1() {
        return tag1;
    }

    public void setTag1(Double tag1) {
        this.tag1 = tag1;
    }

    public Double getTag2() {
        return tag2;
    }

    public void setTag2(Double tag2) {
        this.tag2 = tag2;
    }

    public Double getTag3() {
        return tag3;
    }

    public void setTag3(Double tag3) {
        this.tag3 = tag3;
    }

    public Double getTag4() {
        return tag4;
    }

    public void setTag4(Double tag4) {
        this.tag4 = tag4;
    }

    public Double getTag5() {
        return tag5;
    }

    public void setTag5(Double tag5) {
        this.tag5 = tag5;
    }

    public Double getTag6() {
        return tag6;
    }

    public void setTag6(Double tag6) {
        this.tag6 = tag6;
    }

    public Double getTag7() {
        return tag7;
    }

    public void setTag7(Double tag7) {
        this.tag7 = tag7;
    }

    public Double getTag8() {
        return tag8;
    }

    public void setTag8(Double tag8) {
        this.tag8 = tag8;
    }

    public Double getTag9() {
        return tag9;
    }

    public void setTag9(Double tag9) {
        this.tag9 = tag9;
    }

    public Double getTag10() {
        return tag10;
    }

    public void setTag10(Double tag10) {
        this.tag10 = tag10;
    }

    public Double getTag11() {
        return tag11;
    }

    public void setTag11(Double tag11) {
        this.tag11 = tag11;
    }

    public Double getTag12() {
        return tag12;
    }

    public void setTag12(Double tag12) {
        this.tag12 = tag12;
    }

    public Double getTag13() {
        return tag13;
    }

    public void setTag13(Double tag13) {
        this.tag13 = tag13;
    }

    public Double getTag14() {
        return tag14;
    }

    public void setTag14(Double tag14) {
        this.tag14 = tag14;
    }

    public Double getTag15() {
        return tag15;
    }

    public void setTag15(Double tag15) {
        this.tag15 = tag15;
    }

    public Double getTag16() {
        return tag16;
    }

    public void setTag16(Double tag16) {
        this.tag16 = tag16;
    }

    public Double getTag17() {
        return tag17;
    }

    public void setTag17(Double tag17) {
        this.tag17 = tag17;
    }

    public Double getTag18() {
        return tag18;
    }

    public void setTag18(Double tag18) {
        this.tag18 = tag18;
    }

    public Double getTag19() {
        return tag19;
    }

    public void setTag19(Double tag19) {
        this.tag19 = tag19;
    }

    public Double getTag20() {
        return tag20;
    }

    public void setTag20(Double tag20) {
        this.tag20 = tag20;
    }

    public Double getTag21() {
        return tag21;
    }

    public void setTag21(Double tag21) {
        this.tag21 = tag21;
    }

    public Double getTag22() {
        return tag22;
    }

    public void setTag22(Double tag22) {
        this.tag22 = tag22;
    }

    public Double getTag23() {
        return tag23;
    }

    public void setTag23(Double tag23) {
        this.tag23 = tag23;
    }

    public Double getTag24() {
        return tag24;
    }

    public void setTag24(Double tag24) {
        this.tag24 = tag24;
    }

    public Double getTag25() {
        return tag25;
    }

    public void setTag25(Double tag25) {
        this.tag25 = tag25;
    }

    public Double getTag26() {
        return tag26;
    }

    public void setTag26(Double tag26) {
        this.tag26 = tag26;
    }

    public Double getTag27() {
        return tag27;
    }

    public void setTag27(Double tag27) {
        this.tag27 = tag27;
    }

    public Double getTag28() {
        return tag28;
    }

    public void setTag28(Double tag28) {
        this.tag28 = tag28;
    }

    public Double getTag29() {
        return tag29;
    }

    public void setTag29(Double tag29) {
        this.tag29 = tag29;
    }

    public Double getTag30() {
        return tag30;
    }

    public void setTag30(Double tag30) {
        this.tag30 = tag30;
    }

    public Double getTag31() {
        return tag31;
    }

    public void setTag31(Double tag31) {
        this.tag31 = tag31;
    }

    public Double getTag32() {
        return tag32;
    }

    public void setTag32(Double tag32) {
        this.tag32 = tag32;
    }

    public Double getTag33() {
        return tag33;
    }

    public void setTag33(Double tag33) {
        this.tag33 = tag33;
    }

    public Double getTag34() {
        return tag34;
    }

    public void setTag34(Double tag34) {
        this.tag34 = tag34;
    }

    public Double getTag35() {
        return tag35;
    }

    public void setTag35(Double tag35) {
        this.tag35 = tag35;
    }

    public Double getTag36() {
        return tag36;
    }

    public void setTag36(Double tag36) {
        this.tag36 = tag36;
    }

    public Double getTag37() {
        return tag37;
    }

    public void setTag37(Double tag37) {
        this.tag37 = tag37;
    }

    public Double getTag38() {
        return tag38;
    }

    public void setTag38(Double tag38) {
        this.tag38 = tag38;
    }

    public Double getTag39() {
        return tag39;
    }

    public void setTag39(Double tag39) {
        this.tag39 = tag39;
    }

    public Double getTag40() {
        return tag40;
    }

    public void setTag40(Double tag40) {
        this.tag40 = tag40;
    }

    public Double getTag41() {
        return tag41;
    }

    public void setTag41(Double tag41) {
        this.tag41 = tag41;
    }

    public Double getTag42() {
        return tag42;
    }

    public void setTag42(Double tag42) {
        this.tag42 = tag42;
    }

    public Double getTag43() {
        return tag43;
    }

    public void setTag43(Double tag43) {
        this.tag43 = tag43;
    }

    public Double getTag44() {
        return tag44;
    }

    public void setTag44(Double tag44) {
        this.tag44 = tag44;
    }

    public Double getTag45() {
        return tag45;
    }

    public void setTag45(Double tag45) {
        this.tag45 = tag45;
    }

    public Double getTag46() {
        return tag46;
    }

    public void setTag46(Double tag46) {
        this.tag46 = tag46;
    }

    public Double getTag47() {
        return tag47;
    }

    public void setTag47(Double tag47) {
        this.tag47 = tag47;
    }

    public Double getTag48() {
        return tag48;
    }

    public void setTag48(Double tag48) {
        this.tag48 = tag48;
    }

    public Double getTag49() {
        return tag49;
    }

    public void setTag49(Double tag49) {
        this.tag49 = tag49;
    }

    public Double getTag50() {
        return tag50;
    }

    public void setTag50(Double tag50) {
        this.tag50 = tag50;
    }

    public Double getTag51() {
        return tag51;
    }

    public void setTag51(Double tag51) {
        this.tag51 = tag51;
    }

    public Double getTag52() {
        return tag52;
    }

    public void setTag52(Double tag52) {
        this.tag52 = tag52;
    }

    public Double getTag53() {
        return tag53;
    }

    public void setTag53(Double tag53) {
        this.tag53 = tag53;
    }

    public Double getTag54() {
        return tag54;
    }

    public void setTag54(Double tag54) {
        this.tag54 = tag54;
    }

    public Double getTag55() {
        return tag55;
    }

    public void setTag55(Double tag55) {
        this.tag55 = tag55;
    }

    public Double getTag56() {
        return tag56;
    }

    public void setTag56(Double tag56) {
        this.tag56 = tag56;
    }

    public Double getTag57() {
        return tag57;
    }

    public void setTag57(Double tag57) {
        this.tag57 = tag57;
    }

    public Double getTag58() {
        return tag58;
    }

    public void setTag58(Double tag58) {
        this.tag58 = tag58;
    }

    public Double getTag59() {
        return tag59;
    }

    public void setTag59(Double tag59) {
        this.tag59 = tag59;
    }

    public Double getTag60() {
        return tag60;
    }

    public void setTag60(Double tag60) {
        this.tag60 = tag60;
    }

    public Double getTag61() {
        return tag61;
    }

    public void setTag61(Double tag61) {
        this.tag61 = tag61;
    }

    public Double getTag62() {
        return tag62;
    }

    public void setTag62(Double tag62) {
        this.tag62 = tag62;
    }

    public Double getTag63() {
        return tag63;
    }

    public void setTag63(Double tag63) {
        this.tag63 = tag63;
    }

    public Double getTag64() {
        return tag64;
    }

    public void setTag64(Double tag64) {
        this.tag64 = tag64;
    }

    public Double getTag65() {
        return tag65;
    }

    public void setTag65(Double tag65) {
        this.tag65 = tag65;
    }

    public Double getTag66() {
        return tag66;
    }

    public void setTag66(Double tag66) {
        this.tag66 = tag66;
    }

    public Double getTag67() {
        return tag67;
    }

    public void setTag67(Double tag67) {
        this.tag67 = tag67;
    }

    public Double getTag68() {
        return tag68;
    }

    public void setTag68(Double tag68) {
        this.tag68 = tag68;
    }

    public Double getTag69() {
        return tag69;
    }

    public void setTag69(Double tag69) {
        this.tag69 = tag69;
    }

    public Double getTag70() {
        return tag70;
    }

    public void setTag70(Double tag70) {
        this.tag70 = tag70;
    }

    public Double getTag71() {
        return tag71;
    }

    public void setTag71(Double tag71) {
        this.tag71 = tag71;
    }

    public Double getTag72() {
        return tag72;
    }

    public void setTag72(Double tag72) {
        this.tag72 = tag72;
    }

    public Double getTag73() {
        return tag73;
    }

    public void setTag73(Double tag73) {
        this.tag73 = tag73;
    }

    public Double getTag74() {
        return tag74;
    }

    public void setTag74(Double tag74) {
        this.tag74 = tag74;
    }

    public Double getTag75() {
        return tag75;
    }

    public void setTag75(Double tag75) {
        this.tag75 = tag75;
    }

    public Double getTag76() {
        return tag76;
    }

    public void setTag76(Double tag76) {
        this.tag76 = tag76;
    }

    public Double getTag77() {
        return tag77;
    }

    public void setTag77(Double tag77) {
        this.tag77 = tag77;
    }

    public Double getTag78() {
        return tag78;
    }

    public void setTag78(Double tag78) {
        this.tag78 = tag78;
    }

    public Double getTag79() {
        return tag79;
    }

    public void setTag79(Double tag79) {
        this.tag79 = tag79;
    }

    public Double getTag80() {
        return tag80;
    }

    public void setTag80(Double tag80) {
        this.tag80 = tag80;
    }

    public Double getTag81() {
        return tag81;
    }

    public void setTag81(Double tag81) {
        this.tag81 = tag81;
    }

    public Double getTag82() {
        return tag82;
    }

    public void setTag82(Double tag82) {
        this.tag82 = tag82;
    }

    public Double getTag83() {
        return tag83;
    }

    public void setTag83(Double tag83) {
        this.tag83 = tag83;
    }

    public Double getTag84() {
        return tag84;
    }

    public void setTag84(Double tag84) {
        this.tag84 = tag84;
    }

    public Double getTag85() {
        return tag85;
    }

    public void setTag85(Double tag85) {
        this.tag85 = tag85;
    }

    public Double getTag86() {
        return tag86;
    }

    public void setTag86(Double tag86) {
        this.tag86 = tag86;
    }

    public Double getTag87() {
        return tag87;
    }

    public void setTag87(Double tag87) {
        this.tag87 = tag87;
    }

    public Double getTag88() {
        return tag88;
    }

    public void setTag88(Double tag88) {
        this.tag88 = tag88;
    }

    public Double getTag89() {
        return tag89;
    }

    public void setTag89(Double tag89) {
        this.tag89 = tag89;
    }

    public Double getTag90() {
        return tag90;
    }

    public void setTag90(Double tag90) {
        this.tag90 = tag90;
    }

    public Double getTag91() {
        return tag91;
    }

    public void setTag91(Double tag91) {
        this.tag91 = tag91;
    }

    public Double getTag92() {
        return tag92;
    }

    public void setTag92(Double tag92) {
        this.tag92 = tag92;
    }

    public Double getTag93() {
        return tag93;
    }

    public void setTag93(Double tag93) {
        this.tag93 = tag93;
    }

    public Double getTag94() {
        return tag94;
    }

    public void setTag94(Double tag94) {
        this.tag94 = tag94;
    }

    public Double getTag95() {
        return tag95;
    }

    public void setTag95(Double tag95) {
        this.tag95 = tag95;
    }

    public Double getTag96() {
        return tag96;
    }

    public void setTag96(Double tag96) {
        this.tag96 = tag96;
    }

    public Double getTag97() {
        return tag97;
    }

    public void setTag97(Double tag97) {
        this.tag97 = tag97;
    }

    public Double getTag98() {
        return tag98;
    }

    public void setTag98(Double tag98) {
        this.tag98 = tag98;
    }

    public Double getTag99() {
        return tag99;
    }

    public void setTag99(Double tag99) {
        this.tag99 = tag99;
    }

    public Double getTag100() {
        return tag100;
    }

    public void setTag100(Double tag100) {
        this.tag100 = tag100;
    }

    public Double getTag101() {
        return tag101;
    }

    public void setTag101(Double tag101) {
        this.tag101 = tag101;
    }

    public Double getTag102() {
        return tag102;
    }

    public void setTag102(Double tag102) {
        this.tag102 = tag102;
    }

    public Double getTag103() {
        return tag103;
    }

    public void setTag103(Double tag103) {
        this.tag103 = tag103;
    }

    public Double getTag104() {
        return tag104;
    }

    public void setTag104(Double tag104) {
        this.tag104 = tag104;
    }

    public Double getTag105() {
        return tag105;
    }

    public void setTag105(Double tag105) {
        this.tag105 = tag105;
    }

    public Double getTag106() {
        return tag106;
    }

    public void setTag106(Double tag106) {
        this.tag106 = tag106;
    }

    public Double getTag107() {
        return tag107;
    }

    public void setTag107(Double tag107) {
        this.tag107 = tag107;
    }

    public Double getTag108() {
        return tag108;
    }

    public void setTag108(Double tag108) {
        this.tag108 = tag108;
    }

    public Double getTag109() {
        return tag109;
    }

    public void setTag109(Double tag109) {
        this.tag109 = tag109;
    }

    public Double getTag110() {
        return tag110;
    }

    public void setTag110(Double tag110) {
        this.tag110 = tag110;
    }

    public Double getTag111() {
        return tag111;
    }

    public void setTag111(Double tag111) {
        this.tag111 = tag111;
    }

    public Double getTag112() {
        return tag112;
    }

    public void setTag112(Double tag112) {
        this.tag112 = tag112;
    }

    public Double getTag113() {
        return tag113;
    }

    public void setTag113(Double tag113) {
        this.tag113 = tag113;
    }

    public Double getTag114() {
        return tag114;
    }

    public void setTag114(Double tag114) {
        this.tag114 = tag114;
    }

    public Double getTag115() {
        return tag115;
    }

    public void setTag115(Double tag115) {
        this.tag115 = tag115;
    }

    public Double getTag116() {
        return tag116;
    }

    public void setTag116(Double tag116) {
        this.tag116 = tag116;
    }

    public Double getTag117() {
        return tag117;
    }

    public void setTag117(Double tag117) {
        this.tag117 = tag117;
    }

    public Double getTag118() {
        return tag118;
    }

    public void setTag118(Double tag118) {
        this.tag118 = tag118;
    }

    public Double getTag119() {
        return tag119;
    }

    public void setTag119(Double tag119) {
        this.tag119 = tag119;
    }

    public Double getTag120() {
        return tag120;
    }

    public void setTag120(Double tag120) {
        this.tag120 = tag120;
    }

    public Double getTag121() {
        return tag121;
    }

    public void setTag121(Double tag121) {
        this.tag121 = tag121;
    }

    public Double getTag122() {
        return tag122;
    }

    public void setTag122(Double tag122) {
        this.tag122 = tag122;
    }

    public Double getTag123() {
        return tag123;
    }

    public void setTag123(Double tag123) {
        this.tag123 = tag123;
    }

    public Double getTag124() {
        return tag124;
    }

    public void setTag124(Double tag124) {
        this.tag124 = tag124;
    }

    public Double getTag125() {
        return tag125;
    }

    public void setTag125(Double tag125) {
        this.tag125 = tag125;
    }

    public Double getTag126() {
        return tag126;
    }

    public void setTag126(Double tag126) {
        this.tag126 = tag126;
    }

    public Double getTag127() {
        return tag127;
    }

    public void setTag127(Double tag127) {
        this.tag127 = tag127;
    }

    public Double getTag128() {
        return tag128;
    }

    public void setTag128(Double tag128) {
        this.tag128 = tag128;
    }

    public Double getTag129() {
        return tag129;
    }

    public void setTag129(Double tag129) {
        this.tag129 = tag129;
    }

    public Double getTag130() {
        return tag130;
    }

    public void setTag130(Double tag130) {
        this.tag130 = tag130;
    }

    public Double getTag131() {
        return tag131;
    }

    public void setTag131(Double tag131) {
        this.tag131 = tag131;
    }

    public Double getTag132() {
        return tag132;
    }

    public void setTag132(Double tag132) {
        this.tag132 = tag132;
    }

    public Double getTag133() {
        return tag133;
    }

    public void setTag133(Double tag133) {
        this.tag133 = tag133;
    }

    public Double getTag134() {
        return tag134;
    }

    public void setTag134(Double tag134) {
        this.tag134 = tag134;
    }

    public Double getTag135() {
        return tag135;
    }

    public void setTag135(Double tag135) {
        this.tag135 = tag135;
    }

    public Double getTag136() {
        return tag136;
    }

    public void setTag136(Double tag136) {
        this.tag136 = tag136;
    }

    public Double getTag137() {
        return tag137;
    }

    public void setTag137(Double tag137) {
        this.tag137 = tag137;
    }

    public Double getTag138() {
        return tag138;
    }

    public void setTag138(Double tag138) {
        this.tag138 = tag138;
    }

    public Double getTag139() {
        return tag139;
    }

    public void setTag139(Double tag139) {
        this.tag139 = tag139;
    }

    public Double getTag140() {
        return tag140;
    }

    public void setTag140(Double tag140) {
        this.tag140 = tag140;
    }

    public Double getTag141() {
        return tag141;
    }

    public void setTag141(Double tag141) {
        this.tag141 = tag141;
    }

    public Double getTag142() {
        return tag142;
    }

    public void setTag142(Double tag142) {
        this.tag142 = tag142;
    }

    public Double getTag143() {
        return tag143;
    }

    public void setTag143(Double tag143) {
        this.tag143 = tag143;
    }

    public Double getTag144() {
        return tag144;
    }

    public void setTag144(Double tag144) {
        this.tag144 = tag144;
    }

    public Double getTag145() {
        return tag145;
    }

    public void setTag145(Double tag145) {
        this.tag145 = tag145;
    }

    public Double getTag146() {
        return tag146;
    }

    public void setTag146(Double tag146) {
        this.tag146 = tag146;
    }

    public Double getTag147() {
        return tag147;
    }

    public void setTag147(Double tag147) {
        this.tag147 = tag147;
    }

    public Double getTag148() {
        return tag148;
    }

    public void setTag148(Double tag148) {
        this.tag148 = tag148;
    }

    public Double getTag149() {
        return tag149;
    }

    public void setTag149(Double tag149) {
        this.tag149 = tag149;
    }

    public Double getTag150() {
        return tag150;
    }

    public void setTag150(Double tag150) {
        this.tag150 = tag150;
    }

    public Double getTag151() {
        return tag151;
    }

    public void setTag151(Double tag151) {
        this.tag151 = tag151;
    }

    public Double getTag152() {
        return tag152;
    }

    public void setTag152(Double tag152) {
        this.tag152 = tag152;
    }

    public Double getTag153() {
        return tag153;
    }

    public void setTag153(Double tag153) {
        this.tag153 = tag153;
    }

    public Double getTag154() {
        return tag154;
    }

    public void setTag154(Double tag154) {
        this.tag154 = tag154;
    }

    public Double getTag155() {
        return tag155;
    }

    public void setTag155(Double tag155) {
        this.tag155 = tag155;
    }

    public Double getTag156() {
        return tag156;
    }

    public void setTag156(Double tag156) {
        this.tag156 = tag156;
    }

    public Double getTag157() {
        return tag157;
    }

    public void setTag157(Double tag157) {
        this.tag157 = tag157;
    }

    public Double getTag158() {
        return tag158;
    }

    public void setTag158(Double tag158) {
        this.tag158 = tag158;
    }

    public Double getTag159() {
        return tag159;
    }

    public void setTag159(Double tag159) {
        this.tag159 = tag159;
    }

    public Double getTag160() {
        return tag160;
    }

    public void setTag160(Double tag160) {
        this.tag160 = tag160;
    }

    public Double getTag161() {
        return tag161;
    }

    public void setTag161(Double tag161) {
        this.tag161 = tag161;
    }

    public Double getTag162() {
        return tag162;
    }

    public void setTag162(Double tag162) {
        this.tag162 = tag162;
    }

    public Double getTag163() {
        return tag163;
    }

    public void setTag163(Double tag163) {
        this.tag163 = tag163;
    }

    public Double getTag164() {
        return tag164;
    }

    public void setTag164(Double tag164) {
        this.tag164 = tag164;
    }

    public Double getTag165() {
        return tag165;
    }

    public void setTag165(Double tag165) {
        this.tag165 = tag165;
    }

    public Double getTag166() {
        return tag166;
    }

    public void setTag166(Double tag166) {
        this.tag166 = tag166;
    }

    public Double getTag167() {
        return tag167;
    }

    public void setTag167(Double tag167) {
        this.tag167 = tag167;
    }

    public Double getTag168() {
        return tag168;
    }

    public void setTag168(Double tag168) {
        this.tag168 = tag168;
    }

    public Double getTag169() {
        return tag169;
    }

    public void setTag169(Double tag169) {
        this.tag169 = tag169;
    }

    public Double getTag170() {
        return tag170;
    }

    public void setTag170(Double tag170) {
        this.tag170 = tag170;
    }

    public Double getTag171() {
        return tag171;
    }

    public void setTag171(Double tag171) {
        this.tag171 = tag171;
    }

    public Double getTag172() {
        return tag172;
    }

    public void setTag172(Double tag172) {
        this.tag172 = tag172;
    }

    public Double getTag173() {
        return tag173;
    }

    public void setTag173(Double tag173) {
        this.tag173 = tag173;
    }

    public Double getTag174() {
        return tag174;
    }

    public void setTag174(Double tag174) {
        this.tag174 = tag174;
    }

    public Double getTag175() {
        return tag175;
    }

    public void setTag175(Double tag175) {
        this.tag175 = tag175;
    }

    public Double getTag176() {
        return tag176;
    }

    public void setTag176(Double tag176) {
        this.tag176 = tag176;
    }

    public Double getTag177() {
        return tag177;
    }

    public void setTag177(Double tag177) {
        this.tag177 = tag177;
    }

    public Double getTag178() {
        return tag178;
    }

    public void setTag178(Double tag178) {
        this.tag178 = tag178;
    }

    public Double getTag179() {
        return tag179;
    }

    public void setTag179(Double tag179) {
        this.tag179 = tag179;
    }

    public Double getTag180() {
        return tag180;
    }

    public void setTag180(Double tag180) {
        this.tag180 = tag180;
    }

    public Double getTag181() {
        return tag181;
    }

    public void setTag181(Double tag181) {
        this.tag181 = tag181;
    }

    public Double getTag182() {
        return tag182;
    }

    public void setTag182(Double tag182) {
        this.tag182 = tag182;
    }

    public Double getTag183() {
        return tag183;
    }

    public void setTag183(Double tag183) {
        this.tag183 = tag183;
    }

    public Double getTag184() {
        return tag184;
    }

    public void setTag184(Double tag184) {
        this.tag184 = tag184;
    }

    public Double getTag185() {
        return tag185;
    }

    public void setTag185(Double tag185) {
        this.tag185 = tag185;
    }

    public Double getTag186() {
        return tag186;
    }

    public void setTag186(Double tag186) {
        this.tag186 = tag186;
    }

    public Double getTag187() {
        return tag187;
    }

    public void setTag187(Double tag187) {
        this.tag187 = tag187;
    }

    public Double getTag188() {
        return tag188;
    }

    public void setTag188(Double tag188) {
        this.tag188 = tag188;
    }

    public Double getTag189() {
        return tag189;
    }

    public void setTag189(Double tag189) {
        this.tag189 = tag189;
    }

    public Double getTag190() {
        return tag190;
    }

    public void setTag190(Double tag190) {
        this.tag190 = tag190;
    }

    public Double getTag191() {
        return tag191;
    }

    public void setTag191(Double tag191) {
        this.tag191 = tag191;
    }

    public Double getTag192() {
        return tag192;
    }

    public void setTag192(Double tag192) {
        this.tag192 = tag192;
    }

    public Double getTag193() {
        return tag193;
    }

    public void setTag193(Double tag193) {
        this.tag193 = tag193;
    }

    public Double getTag194() {
        return tag194;
    }

    public void setTag194(Double tag194) {
        this.tag194 = tag194;
    }

    public Double getTag195() {
        return tag195;
    }

    public void setTag195(Double tag195) {
        this.tag195 = tag195;
    }

    public Double getTag196() {
        return tag196;
    }

    public void setTag196(Double tag196) {
        this.tag196 = tag196;
    }

    public Double getTag197() {
        return tag197;
    }

    public void setTag197(Double tag197) {
        this.tag197 = tag197;
    }

    public Double getTag198() {
        return tag198;
    }

    public void setTag198(Double tag198) {
        this.tag198 = tag198;
    }

    public Double getTag199() {
        return tag199;
    }

    public void setTag199(Double tag199) {
        this.tag199 = tag199;
    }

    public Double getTag200() {
        return tag200;
    }

    public void setTag200(Double tag200) {
        this.tag200 = tag200;
    }

    public Double getTag201() {
        return tag201;
    }

    public void setTag201(Double tag201) {
        this.tag201 = tag201;
    }

    public Double getTag202() {
        return tag202;
    }

    public void setTag202(Double tag202) {
        this.tag202 = tag202;
    }

    public Double getTag203() {
        return tag203;
    }

    public void setTag203(Double tag203) {
        this.tag203 = tag203;
    }

    public Double getTag204() {
        return tag204;
    }

    public void setTag204(Double tag204) {
        this.tag204 = tag204;
    }

    public Double getTag205() {
        return tag205;
    }

    public void setTag205(Double tag205) {
        this.tag205 = tag205;
    }

    public Double getTag206() {
        return tag206;
    }

    public void setTag206(Double tag206) {
        this.tag206 = tag206;
    }

    public Double getTag207() {
        return tag207;
    }

    public void setTag207(Double tag207) {
        this.tag207 = tag207;
    }

    public Double getTag208() {
        return tag208;
    }

    public void setTag208(Double tag208) {
        this.tag208 = tag208;
    }

    public Double getTag209() {
        return tag209;
    }

    public void setTag209(Double tag209) {
        this.tag209 = tag209;
    }

    public Double getTag210() {
        return tag210;
    }

    public void setTag210(Double tag210) {
        this.tag210 = tag210;
    }

    public Double getTag211() {
        return tag211;
    }

    public void setTag211(Double tag211) {
        this.tag211 = tag211;
    }

    public Double getTag212() {
        return tag212;
    }

    public void setTag212(Double tag212) {
        this.tag212 = tag212;
    }

    public Double getTag213() {
        return tag213;
    }

    public void setTag213(Double tag213) {
        this.tag213 = tag213;
    }

    public Double getTag214() {
        return tag214;
    }

    public void setTag214(Double tag214) {
        this.tag214 = tag214;
    }

    public Double getTag215() {
        return tag215;
    }

    public void setTag215(Double tag215) {
        this.tag215 = tag215;
    }

    public Double getTag216() {
        return tag216;
    }

    public void setTag216(Double tag216) {
        this.tag216 = tag216;
    }

    public Double getTag217() {
        return tag217;
    }

    public void setTag217(Double tag217) {
        this.tag217 = tag217;
    }

    public Double getTag218() {
        return tag218;
    }

    public void setTag218(Double tag218) {
        this.tag218 = tag218;
    }

    public Double getTag219() {
        return tag219;
    }

    public void setTag219(Double tag219) {
        this.tag219 = tag219;
    }

    public Double getTag220() {
        return tag220;
    }

    public void setTag220(Double tag220) {
        this.tag220 = tag220;
    }

    public Double getTag221() {
        return tag221;
    }

    public void setTag221(Double tag221) {
        this.tag221 = tag221;
    }

    public Double getTag222() {
        return tag222;
    }

    public void setTag222(Double tag222) {
        this.tag222 = tag222;
    }

    public Double getTag223() {
        return tag223;
    }

    public void setTag223(Double tag223) {
        this.tag223 = tag223;
    }

    public Double getTag224() {
        return tag224;
    }

    public void setTag224(Double tag224) {
        this.tag224 = tag224;
    }

    public Double getTag225() {
        return tag225;
    }

    public void setTag225(Double tag225) {
        this.tag225 = tag225;
    }

    public Double getTag226() {
        return tag226;
    }

    public void setTag226(Double tag226) {
        this.tag226 = tag226;
    }

    public Double getTag227() {
        return tag227;
    }

    public void setTag227(Double tag227) {
        this.tag227 = tag227;
    }

    public Double getTag228() {
        return tag228;
    }

    public void setTag228(Double tag228) {
        this.tag228 = tag228;
    }

    public Double getTag229() {
        return tag229;
    }

    public void setTag229(Double tag229) {
        this.tag229 = tag229;
    }

    public Double getTag230() {
        return tag230;
    }

    public void setTag230(Double tag230) {
        this.tag230 = tag230;
    }

    public Double getTag231() {
        return tag231;
    }

    public void setTag231(Double tag231) {
        this.tag231 = tag231;
    }

    public Double getTag232() {
        return tag232;
    }

    public void setTag232(Double tag232) {
        this.tag232 = tag232;
    }

    public Double getTag233() {
        return tag233;
    }

    public void setTag233(Double tag233) {
        this.tag233 = tag233;
    }

    public Double getTag234() {
        return tag234;
    }

    public void setTag234(Double tag234) {
        this.tag234 = tag234;
    }

    public Double getTag235() {
        return tag235;
    }

    public void setTag235(Double tag235) {
        this.tag235 = tag235;
    }

    public Double getTag236() {
        return tag236;
    }

    public void setTag236(Double tag236) {
        this.tag236 = tag236;
    }

    public Double getTag237() {
        return tag237;
    }

    public void setTag237(Double tag237) {
        this.tag237 = tag237;
    }

    public Double getTag238() {
        return tag238;
    }

    public void setTag238(Double tag238) {
        this.tag238 = tag238;
    }

    public Double getTag239() {
        return tag239;
    }

    public void setTag239(Double tag239) {
        this.tag239 = tag239;
    }

    public Double getTag240() {
        return tag240;
    }

    public void setTag240(Double tag240) {
        this.tag240 = tag240;
    }

    public Double getTag241() {
        return tag241;
    }

    public void setTag241(Double tag241) {
        this.tag241 = tag241;
    }

    public Double getTag242() {
        return tag242;
    }

    public void setTag242(Double tag242) {
        this.tag242 = tag242;
    }

    public Double getTag243() {
        return tag243;
    }

    public void setTag243(Double tag243) {
        this.tag243 = tag243;
    }

    public Double getTag244() {
        return tag244;
    }

    public void setTag244(Double tag244) {
        this.tag244 = tag244;
    }

    public Double getTag245() {
        return tag245;
    }

    public void setTag245(Double tag245) {
        this.tag245 = tag245;
    }

    public Double getTag246() {
        return tag246;
    }

    public void setTag246(Double tag246) {
        this.tag246 = tag246;
    }

    public Double getTag247() {
        return tag247;
    }

    public void setTag247(Double tag247) {
        this.tag247 = tag247;
    }

    public Double getTag248() {
        return tag248;
    }

    public void setTag248(Double tag248) {
        this.tag248 = tag248;
    }

    public Double getTag249() {
        return tag249;
    }

    public void setTag249(Double tag249) {
        this.tag249 = tag249;
    }

    public Double getTag250() {
        return tag250;
    }

    public void setTag250(Double tag250) {
        this.tag250 = tag250;
    }

    public Double getTag251() {
        return tag251;
    }

    public void setTag251(Double tag251) {
        this.tag251 = tag251;
    }

    public Double getTag252() {
        return tag252;
    }

    public void setTag252(Double tag252) {
        this.tag252 = tag252;
    }

    public Double getTag253() {
        return tag253;
    }

    public void setTag253(Double tag253) {
        this.tag253 = tag253;
    }

    public Double getTag254() {
        return tag254;
    }

    public void setTag254(Double tag254) {
        this.tag254 = tag254;
    }

    public Double getTag255() {
        return tag255;
    }

    public void setTag255(Double tag255) {
        this.tag255 = tag255;
    }

    public Double getTag256() {
        return tag256;
    }

    public void setTag256(Double tag256) {
        this.tag256 = tag256;
    }

    public Double getTag257() {
        return tag257;
    }

    public void setTag257(Double tag257) {
        this.tag257 = tag257;
    }

    public Double getTag258() {
        return tag258;
    }

    public void setTag258(Double tag258) {
        this.tag258 = tag258;
    }

    public Double getTag259() {
        return tag259;
    }

    public void setTag259(Double tag259) {
        this.tag259 = tag259;
    }

    public Double getTag260() {
        return tag260;
    }

    public void setTag260(Double tag260) {
        this.tag260 = tag260;
    }

    public Double getTag261() {
        return tag261;
    }

    public void setTag261(Double tag261) {
        this.tag261 = tag261;
    }

    public Double getTag262() {
        return tag262;
    }

    public void setTag262(Double tag262) {
        this.tag262 = tag262;
    }

    public Double getTag263() {
        return tag263;
    }

    public void setTag263(Double tag263) {
        this.tag263 = tag263;
    }

    public Double getTag264() {
        return tag264;
    }

    public void setTag264(Double tag264) {
        this.tag264 = tag264;
    }

    public Double getTag265() {
        return tag265;
    }

    public void setTag265(Double tag265) {
        this.tag265 = tag265;
    }

    public Double getTag266() {
        return tag266;
    }

    public void setTag266(Double tag266) {
        this.tag266 = tag266;
    }

    public Double getTag267() {
        return tag267;
    }

    public void setTag267(Double tag267) {
        this.tag267 = tag267;
    }

    public Double getTag268() {
        return tag268;
    }

    public void setTag268(Double tag268) {
        this.tag268 = tag268;
    }

    public Double getTag269() {
        return tag269;
    }

    public void setTag269(Double tag269) {
        this.tag269 = tag269;
    }

    public Double getTag270() {
        return tag270;
    }

    public void setTag270(Double tag270) {
        this.tag270 = tag270;
    }

    public Double getTag271() {
        return tag271;
    }

    public void setTag271(Double tag271) {
        this.tag271 = tag271;
    }

    public Double getTag272() {
        return tag272;
    }

    public void setTag272(Double tag272) {
        this.tag272 = tag272;
    }

    public Double getTag273() {
        return tag273;
    }

    public void setTag273(Double tag273) {
        this.tag273 = tag273;
    }

    public Double getTag274() {
        return tag274;
    }

    public void setTag274(Double tag274) {
        this.tag274 = tag274;
    }

    public Double getTag275() {
        return tag275;
    }

    public void setTag275(Double tag275) {
        this.tag275 = tag275;
    }

    public Double getTag276() {
        return tag276;
    }

    public void setTag276(Double tag276) {
        this.tag276 = tag276;
    }

    public Double getTag277() {
        return tag277;
    }

    public void setTag277(Double tag277) {
        this.tag277 = tag277;
    }

    public Double getTag278() {
        return tag278;
    }

    public void setTag278(Double tag278) {
        this.tag278 = tag278;
    }

    public Double getTag279() {
        return tag279;
    }

    public void setTag279(Double tag279) {
        this.tag279 = tag279;
    }

    public Double getTag280() {
        return tag280;
    }

    public void setTag280(Double tag280) {
        this.tag280 = tag280;
    }

    public Double getTag281() {
        return tag281;
    }

    public void setTag281(Double tag281) {
        this.tag281 = tag281;
    }

    public Double getTag282() {
        return tag282;
    }

    public void setTag282(Double tag282) {
        this.tag282 = tag282;
    }

    public Double getTag283() {
        return tag283;
    }

    public void setTag283(Double tag283) {
        this.tag283 = tag283;
    }

    public Double getTag284() {
        return tag284;
    }

    public void setTag284(Double tag284) {
        this.tag284 = tag284;
    }

    public Double getTag285() {
        return tag285;
    }

    public void setTag285(Double tag285) {
        this.tag285 = tag285;
    }

    public Double getTag286() {
        return tag286;
    }

    public void setTag286(Double tag286) {
        this.tag286 = tag286;
    }

    public Double getTag287() {
        return tag287;
    }

    public void setTag287(Double tag287) {
        this.tag287 = tag287;
    }

    public Double getTag288() {
        return tag288;
    }

    public void setTag288(Double tag288) {
        this.tag288 = tag288;
    }

    public Double getTag289() {
        return tag289;
    }

    public void setTag289(Double tag289) {
        this.tag289 = tag289;
    }

    public Double getTag290() {
        return tag290;
    }

    public void setTag290(Double tag290) {
        this.tag290 = tag290;
    }

    public Double getTag291() {
        return tag291;
    }

    public void setTag291(Double tag291) {
        this.tag291 = tag291;
    }

    public Double getTag292() {
        return tag292;
    }

    public void setTag292(Double tag292) {
        this.tag292 = tag292;
    }

    public Double getTag293() {
        return tag293;
    }

    public void setTag293(Double tag293) {
        this.tag293 = tag293;
    }

    public Double getTag294() {
        return tag294;
    }

    public void setTag294(Double tag294) {
        this.tag294 = tag294;
    }

    public Double getTag295() {
        return tag295;
    }

    public void setTag295(Double tag295) {
        this.tag295 = tag295;
    }

    public Double getTag296() {
        return tag296;
    }

    public void setTag296(Double tag296) {
        this.tag296 = tag296;
    }

    public Double getTag297() {
        return tag297;
    }

    public void setTag297(Double tag297) {
        this.tag297 = tag297;
    }

    public Double getTag298() {
        return tag298;
    }

    public void setTag298(Double tag298) {
        this.tag298 = tag298;
    }

    public Double getTag299() {
        return tag299;
    }

    public void setTag299(Double tag299) {
        this.tag299 = tag299;
    }

    public Double getTag300() {
        return tag300;
    }

    public void setTag300(Double tag300) {
        this.tag300 = tag300;
    }

    public Double getTag301() {
        return tag301;
    }

    public void setTag301(Double tag301) {
        this.tag301 = tag301;
    }

    public Double getTag302() {
        return tag302;
    }

    public void setTag302(Double tag302) {
        this.tag302 = tag302;
    }

    public Double getTag303() {
        return tag303;
    }

    public void setTag303(Double tag303) {
        this.tag303 = tag303;
    }

    public Double getTag304() {
        return tag304;
    }

    public void setTag304(Double tag304) {
        this.tag304 = tag304;
    }

    public Double getTag305() {
        return tag305;
    }

    public void setTag305(Double tag305) {
        this.tag305 = tag305;
    }

    public Double getTag306() {
        return tag306;
    }

    public void setTag306(Double tag306) {
        this.tag306 = tag306;
    }

    public Double getTag307() {
        return tag307;
    }

    public void setTag307(Double tag307) {
        this.tag307 = tag307;
    }

    public Double getTag308() {
        return tag308;
    }

    public void setTag308(Double tag308) {
        this.tag308 = tag308;
    }

    public Double getTag309() {
        return tag309;
    }

    public void setTag309(Double tag309) {
        this.tag309 = tag309;
    }

    public Double getTag310() {
        return tag310;
    }

    public void setTag310(Double tag310) {
        this.tag310 = tag310;
    }

    public Double getTag311() {
        return tag311;
    }

    public void setTag311(Double tag311) {
        this.tag311 = tag311;
    }

    public Double getTag312() {
        return tag312;
    }

    public void setTag312(Double tag312) {
        this.tag312 = tag312;
    }

    public Double getTag313() {
        return tag313;
    }

    public void setTag313(Double tag313) {
        this.tag313 = tag313;
    }

    public Double getTag314() {
        return tag314;
    }

    public void setTag314(Double tag314) {
        this.tag314 = tag314;
    }

    public Double getTag315() {
        return tag315;
    }

    public void setTag315(Double tag315) {
        this.tag315 = tag315;
    }

    public Double getTag316() {
        return tag316;
    }

    public void setTag316(Double tag316) {
        this.tag316 = tag316;
    }

    public Double getTag317() {
        return tag317;
    }

    public void setTag317(Double tag317) {
        this.tag317 = tag317;
    }

    public Double getTag318() {
        return tag318;
    }

    public void setTag318(Double tag318) {
        this.tag318 = tag318;
    }

    public Double getTag319() {
        return tag319;
    }

    public void setTag319(Double tag319) {
        this.tag319 = tag319;
    }

    public Double getTag320() {
        return tag320;
    }

    public void setTag320(Double tag320) {
        this.tag320 = tag320;
    }

    public Double getTag321() {
        return tag321;
    }

    public void setTag321(Double tag321) {
        this.tag321 = tag321;
    }

    public Double getTag322() {
        return tag322;
    }

    public void setTag322(Double tag322) {
        this.tag322 = tag322;
    }

    public Double getTag323() {
        return tag323;
    }

    public void setTag323(Double tag323) {
        this.tag323 = tag323;
    }

    public Double getTag324() {
        return tag324;
    }

    public void setTag324(Double tag324) {
        this.tag324 = tag324;
    }

    public Double getTag325() {
        return tag325;
    }

    public void setTag325(Double tag325) {
        this.tag325 = tag325;
    }

    public Double getTag326() {
        return tag326;
    }

    public void setTag326(Double tag326) {
        this.tag326 = tag326;
    }

    public Double getTag327() {
        return tag327;
    }

    public void setTag327(Double tag327) {
        this.tag327 = tag327;
    }

    public Double getTag328() {
        return tag328;
    }

    public void setTag328(Double tag328) {
        this.tag328 = tag328;
    }

    public Double getTag329() {
        return tag329;
    }

    public void setTag329(Double tag329) {
        this.tag329 = tag329;
    }

    public Double getTag330() {
        return tag330;
    }

    public void setTag330(Double tag330) {
        this.tag330 = tag330;
    }

    public Double getTag331() {
        return tag331;
    }

    public void setTag331(Double tag331) {
        this.tag331 = tag331;
    }

    public Double getTag332() {
        return tag332;
    }

    public void setTag332(Double tag332) {
        this.tag332 = tag332;
    }

    public Double getTag333() {
        return tag333;
    }

    public void setTag333(Double tag333) {
        this.tag333 = tag333;
    }

    public Double getTag334() {
        return tag334;
    }

    public void setTag334(Double tag334) {
        this.tag334 = tag334;
    }

    public Double getTag335() {
        return tag335;
    }

    public void setTag335(Double tag335) {
        this.tag335 = tag335;
    }

    public Double getTag336() {
        return tag336;
    }

    public void setTag336(Double tag336) {
        this.tag336 = tag336;
    }

    public Double getTag337() {
        return tag337;
    }

    public void setTag337(Double tag337) {
        this.tag337 = tag337;
    }

    public Double getTag338() {
        return tag338;
    }

    public void setTag338(Double tag338) {
        this.tag338 = tag338;
    }

    public Double getTag339() {
        return tag339;
    }

    public void setTag339(Double tag339) {
        this.tag339 = tag339;
    }

    public Double getTag340() {
        return tag340;
    }

    public void setTag340(Double tag340) {
        this.tag340 = tag340;
    }

    public Double getTag341() {
        return tag341;
    }

    public void setTag341(Double tag341) {
        this.tag341 = tag341;
    }

    public Double getTag342() {
        return tag342;
    }

    public void setTag342(Double tag342) {
        this.tag342 = tag342;
    }

    public Double getTag343() {
        return tag343;
    }

    public void setTag343(Double tag343) {
        this.tag343 = tag343;
    }

    public Double getTag344() {
        return tag344;
    }

    public void setTag344(Double tag344) {
        this.tag344 = tag344;
    }

    public Double getTag345() {
        return tag345;
    }

    public void setTag345(Double tag345) {
        this.tag345 = tag345;
    }

    public Double getTag346() {
        return tag346;
    }

    public void setTag346(Double tag346) {
        this.tag346 = tag346;
    }

    public Double getTag347() {
        return tag347;
    }

    public void setTag347(Double tag347) {
        this.tag347 = tag347;
    }

    public Double getTag348() {
        return tag348;
    }

    public void setTag348(Double tag348) {
        this.tag348 = tag348;
    }

    public Double getTag349() {
        return tag349;
    }

    public void setTag349(Double tag349) {
        this.tag349 = tag349;
    }

    public Double getTag350() {
        return tag350;
    }

    public void setTag350(Double tag350) {
        this.tag350 = tag350;
    }

    public Double getTag351() {
        return tag351;
    }

    public void setTag351(Double tag351) {
        this.tag351 = tag351;
    }

    public Double getTag352() {
        return tag352;
    }

    public void setTag352(Double tag352) {
        this.tag352 = tag352;
    }

    public Double getTag353() {
        return tag353;
    }

    public void setTag353(Double tag353) {
        this.tag353 = tag353;
    }

    public Double getTag354() {
        return tag354;
    }

    public void setTag354(Double tag354) {
        this.tag354 = tag354;
    }

    public Double getTag355() {
        return tag355;
    }

    public void setTag355(Double tag355) {
        this.tag355 = tag355;
    }

    public Double getTag356() {
        return tag356;
    }

    public void setTag356(Double tag356) {
        this.tag356 = tag356;
    }

    public Double getTag357() {
        return tag357;
    }

    public void setTag357(Double tag357) {
        this.tag357 = tag357;
    }

    public Double getTag358() {
        return tag358;
    }

    public void setTag358(Double tag358) {
        this.tag358 = tag358;
    }

    public Double getTag359() {
        return tag359;
    }

    public void setTag359(Double tag359) {
        this.tag359 = tag359;
    }

    public Double getTag360() {
        return tag360;
    }

    public void setTag360(Double tag360) {
        this.tag360 = tag360;
    }

    public Double getTag361() {
        return tag361;
    }

    public void setTag361(Double tag361) {
        this.tag361 = tag361;
    }

    public Double getTag362() {
        return tag362;
    }

    public void setTag362(Double tag362) {
        this.tag362 = tag362;
    }

    public Double getTag363() {
        return tag363;
    }

    public void setTag363(Double tag363) {
        this.tag363 = tag363;
    }

    public Double getTag364() {
        return tag364;
    }

    public void setTag364(Double tag364) {
        this.tag364 = tag364;
    }

    public Double getTag365() {
        return tag365;
    }

    public void setTag365(Double tag365) {
        this.tag365 = tag365;
    }

    public Double getTag366() {
        return tag366;
    }

    public void setTag366(Double tag366) {
        this.tag366 = tag366;
    }

    public Double getTag367() {
        return tag367;
    }

    public void setTag367(Double tag367) {
        this.tag367 = tag367;
    }

    public Double getTag368() {
        return tag368;
    }

    public void setTag368(Double tag368) {
        this.tag368 = tag368;
    }

    public Double getTag369() {
        return tag369;
    }

    public void setTag369(Double tag369) {
        this.tag369 = tag369;
    }

    public Double getTag370() {
        return tag370;
    }

    public void setTag370(Double tag370) {
        this.tag370 = tag370;
    }

    public Double getTag371() {
        return tag371;
    }

    public void setTag371(Double tag371) {
        this.tag371 = tag371;
    }

    public Double getTag372() {
        return tag372;
    }

    public void setTag372(Double tag372) {
        this.tag372 = tag372;
    }

    public Double getTag373() {
        return tag373;
    }

    public void setTag373(Double tag373) {
        this.tag373 = tag373;
    }

    public Double getTag374() {
        return tag374;
    }

    public void setTag374(Double tag374) {
        this.tag374 = tag374;
    }

    public Double getTag375() {
        return tag375;
    }

    public void setTag375(Double tag375) {
        this.tag375 = tag375;
    }

    public Double getTag376() {
        return tag376;
    }

    public void setTag376(Double tag376) {
        this.tag376 = tag376;
    }

    public Double getTag377() {
        return tag377;
    }

    public void setTag377(Double tag377) {
        this.tag377 = tag377;
    }

    public Double getTag378() {
        return tag378;
    }

    public void setTag378(Double tag378) {
        this.tag378 = tag378;
    }

    public Double getTag379() {
        return tag379;
    }

    public void setTag379(Double tag379) {
        this.tag379 = tag379;
    }

    public Double getTag380() {
        return tag380;
    }

    public void setTag380(Double tag380) {
        this.tag380 = tag380;
    }

    public Double getTag381() {
        return tag381;
    }

    public void setTag381(Double tag381) {
        this.tag381 = tag381;
    }

    public Double getTag382() {
        return tag382;
    }

    public void setTag382(Double tag382) {
        this.tag382 = tag382;
    }

    public Double getTag383() {
        return tag383;
    }

    public void setTag383(Double tag383) {
        this.tag383 = tag383;
    }

    public Double getTag384() {
        return tag384;
    }

    public void setTag384(Double tag384) {
        this.tag384 = tag384;
    }

    public Double getTag385() {
        return tag385;
    }

    public void setTag385(Double tag385) {
        this.tag385 = tag385;
    }

    public Double getTag386() {
        return tag386;
    }

    public void setTag386(Double tag386) {
        this.tag386 = tag386;
    }

    public Double getTag387() {
        return tag387;
    }

    public void setTag387(Double tag387) {
        this.tag387 = tag387;
    }

    public Double getTag388() {
        return tag388;
    }

    public void setTag388(Double tag388) {
        this.tag388 = tag388;
    }

    public Double getTag389() {
        return tag389;
    }

    public void setTag389(Double tag389) {
        this.tag389 = tag389;
    }

    public Double getTag390() {
        return tag390;
    }

    public void setTag390(Double tag390) {
        this.tag390 = tag390;
    }

    public Double getTag391() {
        return tag391;
    }

    public void setTag391(Double tag391) {
        this.tag391 = tag391;
    }

    public Double getTag392() {
        return tag392;
    }

    public void setTag392(Double tag392) {
        this.tag392 = tag392;
    }

    public Double getTag393() {
        return tag393;
    }

    public void setTag393(Double tag393) {
        this.tag393 = tag393;
    }

    public Double getTag394() {
        return tag394;
    }

    public void setTag394(Double tag394) {
        this.tag394 = tag394;
    }

    public Double getTag395() {
        return tag395;
    }

    public void setTag395(Double tag395) {
        this.tag395 = tag395;
    }

    public Double getTag396() {
        return tag396;
    }

    public void setTag396(Double tag396) {
        this.tag396 = tag396;
    }

    public Double getTag397() {
        return tag397;
    }

    public void setTag397(Double tag397) {
        this.tag397 = tag397;
    }

    public Double getTag398() {
        return tag398;
    }

    public void setTag398(Double tag398) {
        this.tag398 = tag398;
    }

    public Double getTag399() {
        return tag399;
    }

    public void setTag399(Double tag399) {
        this.tag399 = tag399;
    }

    public Double getTag400() {
        return tag400;
    }

    public void setTag400(Double tag400) {
        this.tag400 = tag400;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", clock=").append(clock);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", tag1=").append(tag1);
        sb.append(", tag2=").append(tag2);
        sb.append(", tag3=").append(tag3);
        sb.append(", tag4=").append(tag4);
        sb.append(", tag5=").append(tag5);
        sb.append(", tag6=").append(tag6);
        sb.append(", tag7=").append(tag7);
        sb.append(", tag8=").append(tag8);
        sb.append(", tag9=").append(tag9);
        sb.append(", tag10=").append(tag10);
        sb.append(", tag11=").append(tag11);
        sb.append(", tag12=").append(tag12);
        sb.append(", tag13=").append(tag13);
        sb.append(", tag14=").append(tag14);
        sb.append(", tag15=").append(tag15);
        sb.append(", tag16=").append(tag16);
        sb.append(", tag17=").append(tag17);
        sb.append(", tag18=").append(tag18);
        sb.append(", tag19=").append(tag19);
        sb.append(", tag20=").append(tag20);
        sb.append(", tag21=").append(tag21);
        sb.append(", tag22=").append(tag22);
        sb.append(", tag23=").append(tag23);
        sb.append(", tag24=").append(tag24);
        sb.append(", tag25=").append(tag25);
        sb.append(", tag26=").append(tag26);
        sb.append(", tag27=").append(tag27);
        sb.append(", tag28=").append(tag28);
        sb.append(", tag29=").append(tag29);
        sb.append(", tag30=").append(tag30);
        sb.append(", tag31=").append(tag31);
        sb.append(", tag32=").append(tag32);
        sb.append(", tag33=").append(tag33);
        sb.append(", tag34=").append(tag34);
        sb.append(", tag35=").append(tag35);
        sb.append(", tag36=").append(tag36);
        sb.append(", tag37=").append(tag37);
        sb.append(", tag38=").append(tag38);
        sb.append(", tag39=").append(tag39);
        sb.append(", tag40=").append(tag40);
        sb.append(", tag41=").append(tag41);
        sb.append(", tag42=").append(tag42);
        sb.append(", tag43=").append(tag43);
        sb.append(", tag44=").append(tag44);
        sb.append(", tag45=").append(tag45);
        sb.append(", tag46=").append(tag46);
        sb.append(", tag47=").append(tag47);
        sb.append(", tag48=").append(tag48);
        sb.append(", tag49=").append(tag49);
        sb.append(", tag50=").append(tag50);
        sb.append(", tag51=").append(tag51);
        sb.append(", tag52=").append(tag52);
        sb.append(", tag53=").append(tag53);
        sb.append(", tag54=").append(tag54);
        sb.append(", tag55=").append(tag55);
        sb.append(", tag56=").append(tag56);
        sb.append(", tag57=").append(tag57);
        sb.append(", tag58=").append(tag58);
        sb.append(", tag59=").append(tag59);
        sb.append(", tag60=").append(tag60);
        sb.append(", tag61=").append(tag61);
        sb.append(", tag62=").append(tag62);
        sb.append(", tag63=").append(tag63);
        sb.append(", tag64=").append(tag64);
        sb.append(", tag65=").append(tag65);
        sb.append(", tag66=").append(tag66);
        sb.append(", tag67=").append(tag67);
        sb.append(", tag68=").append(tag68);
        sb.append(", tag69=").append(tag69);
        sb.append(", tag70=").append(tag70);
        sb.append(", tag71=").append(tag71);
        sb.append(", tag72=").append(tag72);
        sb.append(", tag73=").append(tag73);
        sb.append(", tag74=").append(tag74);
        sb.append(", tag75=").append(tag75);
        sb.append(", tag76=").append(tag76);
        sb.append(", tag77=").append(tag77);
        sb.append(", tag78=").append(tag78);
        sb.append(", tag79=").append(tag79);
        sb.append(", tag80=").append(tag80);
        sb.append(", tag81=").append(tag81);
        sb.append(", tag82=").append(tag82);
        sb.append(", tag83=").append(tag83);
        sb.append(", tag84=").append(tag84);
        sb.append(", tag85=").append(tag85);
        sb.append(", tag86=").append(tag86);
        sb.append(", tag87=").append(tag87);
        sb.append(", tag88=").append(tag88);
        sb.append(", tag89=").append(tag89);
        sb.append(", tag90=").append(tag90);
        sb.append(", tag91=").append(tag91);
        sb.append(", tag92=").append(tag92);
        sb.append(", tag93=").append(tag93);
        sb.append(", tag94=").append(tag94);
        sb.append(", tag95=").append(tag95);
        sb.append(", tag96=").append(tag96);
        sb.append(", tag97=").append(tag97);
        sb.append(", tag98=").append(tag98);
        sb.append(", tag99=").append(tag99);
        sb.append(", tag100=").append(tag100);
        sb.append(", tag101=").append(tag101);
        sb.append(", tag102=").append(tag102);
        sb.append(", tag103=").append(tag103);
        sb.append(", tag104=").append(tag104);
        sb.append(", tag105=").append(tag105);
        sb.append(", tag106=").append(tag106);
        sb.append(", tag107=").append(tag107);
        sb.append(", tag108=").append(tag108);
        sb.append(", tag109=").append(tag109);
        sb.append(", tag110=").append(tag110);
        sb.append(", tag111=").append(tag111);
        sb.append(", tag112=").append(tag112);
        sb.append(", tag113=").append(tag113);
        sb.append(", tag114=").append(tag114);
        sb.append(", tag115=").append(tag115);
        sb.append(", tag116=").append(tag116);
        sb.append(", tag117=").append(tag117);
        sb.append(", tag118=").append(tag118);
        sb.append(", tag119=").append(tag119);
        sb.append(", tag120=").append(tag120);
        sb.append(", tag121=").append(tag121);
        sb.append(", tag122=").append(tag122);
        sb.append(", tag123=").append(tag123);
        sb.append(", tag124=").append(tag124);
        sb.append(", tag125=").append(tag125);
        sb.append(", tag126=").append(tag126);
        sb.append(", tag127=").append(tag127);
        sb.append(", tag128=").append(tag128);
        sb.append(", tag129=").append(tag129);
        sb.append(", tag130=").append(tag130);
        sb.append(", tag131=").append(tag131);
        sb.append(", tag132=").append(tag132);
        sb.append(", tag133=").append(tag133);
        sb.append(", tag134=").append(tag134);
        sb.append(", tag135=").append(tag135);
        sb.append(", tag136=").append(tag136);
        sb.append(", tag137=").append(tag137);
        sb.append(", tag138=").append(tag138);
        sb.append(", tag139=").append(tag139);
        sb.append(", tag140=").append(tag140);
        sb.append(", tag141=").append(tag141);
        sb.append(", tag142=").append(tag142);
        sb.append(", tag143=").append(tag143);
        sb.append(", tag144=").append(tag144);
        sb.append(", tag145=").append(tag145);
        sb.append(", tag146=").append(tag146);
        sb.append(", tag147=").append(tag147);
        sb.append(", tag148=").append(tag148);
        sb.append(", tag149=").append(tag149);
        sb.append(", tag150=").append(tag150);
        sb.append(", tag151=").append(tag151);
        sb.append(", tag152=").append(tag152);
        sb.append(", tag153=").append(tag153);
        sb.append(", tag154=").append(tag154);
        sb.append(", tag155=").append(tag155);
        sb.append(", tag156=").append(tag156);
        sb.append(", tag157=").append(tag157);
        sb.append(", tag158=").append(tag158);
        sb.append(", tag159=").append(tag159);
        sb.append(", tag160=").append(tag160);
        sb.append(", tag161=").append(tag161);
        sb.append(", tag162=").append(tag162);
        sb.append(", tag163=").append(tag163);
        sb.append(", tag164=").append(tag164);
        sb.append(", tag165=").append(tag165);
        sb.append(", tag166=").append(tag166);
        sb.append(", tag167=").append(tag167);
        sb.append(", tag168=").append(tag168);
        sb.append(", tag169=").append(tag169);
        sb.append(", tag170=").append(tag170);
        sb.append(", tag171=").append(tag171);
        sb.append(", tag172=").append(tag172);
        sb.append(", tag173=").append(tag173);
        sb.append(", tag174=").append(tag174);
        sb.append(", tag175=").append(tag175);
        sb.append(", tag176=").append(tag176);
        sb.append(", tag177=").append(tag177);
        sb.append(", tag178=").append(tag178);
        sb.append(", tag179=").append(tag179);
        sb.append(", tag180=").append(tag180);
        sb.append(", tag181=").append(tag181);
        sb.append(", tag182=").append(tag182);
        sb.append(", tag183=").append(tag183);
        sb.append(", tag184=").append(tag184);
        sb.append(", tag185=").append(tag185);
        sb.append(", tag186=").append(tag186);
        sb.append(", tag187=").append(tag187);
        sb.append(", tag188=").append(tag188);
        sb.append(", tag189=").append(tag189);
        sb.append(", tag190=").append(tag190);
        sb.append(", tag191=").append(tag191);
        sb.append(", tag192=").append(tag192);
        sb.append(", tag193=").append(tag193);
        sb.append(", tag194=").append(tag194);
        sb.append(", tag195=").append(tag195);
        sb.append(", tag196=").append(tag196);
        sb.append(", tag197=").append(tag197);
        sb.append(", tag198=").append(tag198);
        sb.append(", tag199=").append(tag199);
        sb.append(", tag200=").append(tag200);
        sb.append(", tag201=").append(tag201);
        sb.append(", tag202=").append(tag202);
        sb.append(", tag203=").append(tag203);
        sb.append(", tag204=").append(tag204);
        sb.append(", tag205=").append(tag205);
        sb.append(", tag206=").append(tag206);
        sb.append(", tag207=").append(tag207);
        sb.append(", tag208=").append(tag208);
        sb.append(", tag209=").append(tag209);
        sb.append(", tag210=").append(tag210);
        sb.append(", tag211=").append(tag211);
        sb.append(", tag212=").append(tag212);
        sb.append(", tag213=").append(tag213);
        sb.append(", tag214=").append(tag214);
        sb.append(", tag215=").append(tag215);
        sb.append(", tag216=").append(tag216);
        sb.append(", tag217=").append(tag217);
        sb.append(", tag218=").append(tag218);
        sb.append(", tag219=").append(tag219);
        sb.append(", tag220=").append(tag220);
        sb.append(", tag221=").append(tag221);
        sb.append(", tag222=").append(tag222);
        sb.append(", tag223=").append(tag223);
        sb.append(", tag224=").append(tag224);
        sb.append(", tag225=").append(tag225);
        sb.append(", tag226=").append(tag226);
        sb.append(", tag227=").append(tag227);
        sb.append(", tag228=").append(tag228);
        sb.append(", tag229=").append(tag229);
        sb.append(", tag230=").append(tag230);
        sb.append(", tag231=").append(tag231);
        sb.append(", tag232=").append(tag232);
        sb.append(", tag233=").append(tag233);
        sb.append(", tag234=").append(tag234);
        sb.append(", tag235=").append(tag235);
        sb.append(", tag236=").append(tag236);
        sb.append(", tag237=").append(tag237);
        sb.append(", tag238=").append(tag238);
        sb.append(", tag239=").append(tag239);
        sb.append(", tag240=").append(tag240);
        sb.append(", tag241=").append(tag241);
        sb.append(", tag242=").append(tag242);
        sb.append(", tag243=").append(tag243);
        sb.append(", tag244=").append(tag244);
        sb.append(", tag245=").append(tag245);
        sb.append(", tag246=").append(tag246);
        sb.append(", tag247=").append(tag247);
        sb.append(", tag248=").append(tag248);
        sb.append(", tag249=").append(tag249);
        sb.append(", tag250=").append(tag250);
        sb.append(", tag251=").append(tag251);
        sb.append(", tag252=").append(tag252);
        sb.append(", tag253=").append(tag253);
        sb.append(", tag254=").append(tag254);
        sb.append(", tag255=").append(tag255);
        sb.append(", tag256=").append(tag256);
        sb.append(", tag257=").append(tag257);
        sb.append(", tag258=").append(tag258);
        sb.append(", tag259=").append(tag259);
        sb.append(", tag260=").append(tag260);
        sb.append(", tag261=").append(tag261);
        sb.append(", tag262=").append(tag262);
        sb.append(", tag263=").append(tag263);
        sb.append(", tag264=").append(tag264);
        sb.append(", tag265=").append(tag265);
        sb.append(", tag266=").append(tag266);
        sb.append(", tag267=").append(tag267);
        sb.append(", tag268=").append(tag268);
        sb.append(", tag269=").append(tag269);
        sb.append(", tag270=").append(tag270);
        sb.append(", tag271=").append(tag271);
        sb.append(", tag272=").append(tag272);
        sb.append(", tag273=").append(tag273);
        sb.append(", tag274=").append(tag274);
        sb.append(", tag275=").append(tag275);
        sb.append(", tag276=").append(tag276);
        sb.append(", tag277=").append(tag277);
        sb.append(", tag278=").append(tag278);
        sb.append(", tag279=").append(tag279);
        sb.append(", tag280=").append(tag280);
        sb.append(", tag281=").append(tag281);
        sb.append(", tag282=").append(tag282);
        sb.append(", tag283=").append(tag283);
        sb.append(", tag284=").append(tag284);
        sb.append(", tag285=").append(tag285);
        sb.append(", tag286=").append(tag286);
        sb.append(", tag287=").append(tag287);
        sb.append(", tag288=").append(tag288);
        sb.append(", tag289=").append(tag289);
        sb.append(", tag290=").append(tag290);
        sb.append(", tag291=").append(tag291);
        sb.append(", tag292=").append(tag292);
        sb.append(", tag293=").append(tag293);
        sb.append(", tag294=").append(tag294);
        sb.append(", tag295=").append(tag295);
        sb.append(", tag296=").append(tag296);
        sb.append(", tag297=").append(tag297);
        sb.append(", tag298=").append(tag298);
        sb.append(", tag299=").append(tag299);
        sb.append(", tag300=").append(tag300);
        sb.append(", tag301=").append(tag301);
        sb.append(", tag302=").append(tag302);
        sb.append(", tag303=").append(tag303);
        sb.append(", tag304=").append(tag304);
        sb.append(", tag305=").append(tag305);
        sb.append(", tag306=").append(tag306);
        sb.append(", tag307=").append(tag307);
        sb.append(", tag308=").append(tag308);
        sb.append(", tag309=").append(tag309);
        sb.append(", tag310=").append(tag310);
        sb.append(", tag311=").append(tag311);
        sb.append(", tag312=").append(tag312);
        sb.append(", tag313=").append(tag313);
        sb.append(", tag314=").append(tag314);
        sb.append(", tag315=").append(tag315);
        sb.append(", tag316=").append(tag316);
        sb.append(", tag317=").append(tag317);
        sb.append(", tag318=").append(tag318);
        sb.append(", tag319=").append(tag319);
        sb.append(", tag320=").append(tag320);
        sb.append(", tag321=").append(tag321);
        sb.append(", tag322=").append(tag322);
        sb.append(", tag323=").append(tag323);
        sb.append(", tag324=").append(tag324);
        sb.append(", tag325=").append(tag325);
        sb.append(", tag326=").append(tag326);
        sb.append(", tag327=").append(tag327);
        sb.append(", tag328=").append(tag328);
        sb.append(", tag329=").append(tag329);
        sb.append(", tag330=").append(tag330);
        sb.append(", tag331=").append(tag331);
        sb.append(", tag332=").append(tag332);
        sb.append(", tag333=").append(tag333);
        sb.append(", tag334=").append(tag334);
        sb.append(", tag335=").append(tag335);
        sb.append(", tag336=").append(tag336);
        sb.append(", tag337=").append(tag337);
        sb.append(", tag338=").append(tag338);
        sb.append(", tag339=").append(tag339);
        sb.append(", tag340=").append(tag340);
        sb.append(", tag341=").append(tag341);
        sb.append(", tag342=").append(tag342);
        sb.append(", tag343=").append(tag343);
        sb.append(", tag344=").append(tag344);
        sb.append(", tag345=").append(tag345);
        sb.append(", tag346=").append(tag346);
        sb.append(", tag347=").append(tag347);
        sb.append(", tag348=").append(tag348);
        sb.append(", tag349=").append(tag349);
        sb.append(", tag350=").append(tag350);
        sb.append(", tag351=").append(tag351);
        sb.append(", tag352=").append(tag352);
        sb.append(", tag353=").append(tag353);
        sb.append(", tag354=").append(tag354);
        sb.append(", tag355=").append(tag355);
        sb.append(", tag356=").append(tag356);
        sb.append(", tag357=").append(tag357);
        sb.append(", tag358=").append(tag358);
        sb.append(", tag359=").append(tag359);
        sb.append(", tag360=").append(tag360);
        sb.append(", tag361=").append(tag361);
        sb.append(", tag362=").append(tag362);
        sb.append(", tag363=").append(tag363);
        sb.append(", tag364=").append(tag364);
        sb.append(", tag365=").append(tag365);
        sb.append(", tag366=").append(tag366);
        sb.append(", tag367=").append(tag367);
        sb.append(", tag368=").append(tag368);
        sb.append(", tag369=").append(tag369);
        sb.append(", tag370=").append(tag370);
        sb.append(", tag371=").append(tag371);
        sb.append(", tag372=").append(tag372);
        sb.append(", tag373=").append(tag373);
        sb.append(", tag374=").append(tag374);
        sb.append(", tag375=").append(tag375);
        sb.append(", tag376=").append(tag376);
        sb.append(", tag377=").append(tag377);
        sb.append(", tag378=").append(tag378);
        sb.append(", tag379=").append(tag379);
        sb.append(", tag380=").append(tag380);
        sb.append(", tag381=").append(tag381);
        sb.append(", tag382=").append(tag382);
        sb.append(", tag383=").append(tag383);
        sb.append(", tag384=").append(tag384);
        sb.append(", tag385=").append(tag385);
        sb.append(", tag386=").append(tag386);
        sb.append(", tag387=").append(tag387);
        sb.append(", tag388=").append(tag388);
        sb.append(", tag389=").append(tag389);
        sb.append(", tag390=").append(tag390);
        sb.append(", tag391=").append(tag391);
        sb.append(", tag392=").append(tag392);
        sb.append(", tag393=").append(tag393);
        sb.append(", tag394=").append(tag394);
        sb.append(", tag395=").append(tag395);
        sb.append(", tag396=").append(tag396);
        sb.append(", tag397=").append(tag397);
        sb.append(", tag398=").append(tag398);
        sb.append(", tag399=").append(tag399);
        sb.append(", tag400=").append(tag400);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }

    /**
     * 更新对象属性
     * @param val 值：14732.05
     * @param tag 字段
     * @return
     */
    public void setVal(Double val, String tag) {
		if (tag.equalsIgnoreCase("tag1")) {
			this.setTag1(val);
		} else if (tag.equalsIgnoreCase("tag2")) {
			this.setTag2(val);
		} else if (tag.equalsIgnoreCase("tag3")) {
			this.setTag3(val);
		} else if (tag.equalsIgnoreCase("tag4")) {
			this.setTag4(val);
		} else if (tag.equalsIgnoreCase("tag5")) {
			this.setTag5(val);
		} else if (tag.equalsIgnoreCase("tag6")) {
			this.setTag6(val);
		} else if (tag.equalsIgnoreCase("tag7")) {
			this.setTag7(val);
		} else if (tag.equalsIgnoreCase("tag8")) {
			this.setTag8(val);
		} else if (tag.equalsIgnoreCase("tag9")) {
			this.setTag9(val);
		} else if (tag.equalsIgnoreCase("tag10")) {
			this.setTag10(val);
		} else if (tag.equalsIgnoreCase("tag11")) {
			this.setTag11(val);
		} else if (tag.equalsIgnoreCase("tag12")) {
			this.setTag12(val);
		} else if (tag.equalsIgnoreCase("tag13")) {
			this.setTag13(val);
		} else if (tag.equalsIgnoreCase("tag14")) {
			this.setTag14(val);
		} else if (tag.equalsIgnoreCase("tag15")) {
			this.setTag15(val);
		} else if (tag.equalsIgnoreCase("tag16")) {
			this.setTag16(val);
		} else if (tag.equalsIgnoreCase("tag17")) {
			this.setTag17(val);
		} else if (tag.equalsIgnoreCase("tag18")) {
			this.setTag18(val);
		} else if (tag.equalsIgnoreCase("tag19")) {
			this.setTag19(val);
		} else if (tag.equalsIgnoreCase("tag20")) {
			this.setTag20(val);
		} else if (tag.equalsIgnoreCase("tag21")) {
			this.setTag21(val);
		} else if (tag.equalsIgnoreCase("tag22")) {
			this.setTag22(val);
		} else if (tag.equalsIgnoreCase("tag23")) {
			this.setTag23(val);
		} else if (tag.equalsIgnoreCase("tag24")) {
			this.setTag24(val);
		} else if (tag.equalsIgnoreCase("tag25")) {
			this.setTag25(val);
		} else if (tag.equalsIgnoreCase("tag26")) {
			this.setTag26(val);
		} else if (tag.equalsIgnoreCase("tag27")) {
			this.setTag27(val);
		} else if (tag.equalsIgnoreCase("tag28")) {
			this.setTag28(val);
		} else if (tag.equalsIgnoreCase("tag29")) {
			this.setTag29(val);
		} else if (tag.equalsIgnoreCase("tag30")) {
			this.setTag30(val);
		} else if (tag.equalsIgnoreCase("tag31")) {
			this.setTag31(val);
		} else if (tag.equalsIgnoreCase("tag32")) {
			this.setTag32(val);
		} else if (tag.equalsIgnoreCase("tag33")) {
			this.setTag33(val);
		} else if (tag.equalsIgnoreCase("tag34")) {
			this.setTag34(val);
		} else if (tag.equalsIgnoreCase("tag35")) {
			this.setTag35(val);
		} else if (tag.equalsIgnoreCase("tag36")) {
			this.setTag36(val);
		} else if (tag.equalsIgnoreCase("tag37")) {
			this.setTag37(val);
		} else if (tag.equalsIgnoreCase("tag38")) {
			this.setTag38(val);
		} else if (tag.equalsIgnoreCase("tag39")) {
			this.setTag39(val);
		} else if (tag.equalsIgnoreCase("tag40")) {
			this.setTag40(val);
		} else if (tag.equalsIgnoreCase("tag41")) {
			this.setTag41(val);
		} else if (tag.equalsIgnoreCase("tag42")) {
			this.setTag42(val);
		} else if (tag.equalsIgnoreCase("tag43")) {
			this.setTag43(val);
		} else if (tag.equalsIgnoreCase("tag44")) {
			this.setTag44(val);
		} else if (tag.equalsIgnoreCase("tag45")) {
			this.setTag45(val);
		} else if (tag.equalsIgnoreCase("tag46")) {
			this.setTag46(val);
		} else if (tag.equalsIgnoreCase("tag47")) {
			this.setTag47(val);
		} else if (tag.equalsIgnoreCase("tag48")) {
			this.setTag48(val);
		} else if (tag.equalsIgnoreCase("tag49")) {
			this.setTag49(val);
		} else if (tag.equalsIgnoreCase("tag50")) {
			this.setTag50(val);
		} else if (tag.equalsIgnoreCase("tag51")) {
			this.setTag51(val);
		} else if (tag.equalsIgnoreCase("tag52")) {
			this.setTag52(val);
		} else if (tag.equalsIgnoreCase("tag53")) {
			this.setTag53(val);
		} else if (tag.equalsIgnoreCase("tag54")) {
			this.setTag54(val);
		} else if (tag.equalsIgnoreCase("tag55")) {
			this.setTag55(val);
		} else if (tag.equalsIgnoreCase("tag56")) {
			this.setTag56(val);
		} else if (tag.equalsIgnoreCase("tag57")) {
			this.setTag57(val);
		} else if (tag.equalsIgnoreCase("tag58")) {
			this.setTag58(val);
		} else if (tag.equalsIgnoreCase("tag59")) {
			this.setTag59(val);
		} else if (tag.equalsIgnoreCase("tag60")) {
			this.setTag60(val);
		} else if (tag.equalsIgnoreCase("tag61")) {
			this.setTag61(val);
		} else if (tag.equalsIgnoreCase("tag62")) {
			this.setTag62(val);
		} else if (tag.equalsIgnoreCase("tag63")) {
			this.setTag63(val);
		} else if (tag.equalsIgnoreCase("tag64")) {
			this.setTag64(val);
		} else if (tag.equalsIgnoreCase("tag65")) {
			this.setTag65(val);
		} else if (tag.equalsIgnoreCase("tag66")) {
			this.setTag66(val);
		} else if (tag.equalsIgnoreCase("tag67")) {
			this.setTag67(val);
		} else if (tag.equalsIgnoreCase("tag68")) {
			this.setTag68(val);
		} else if (tag.equalsIgnoreCase("tag69")) {
			this.setTag69(val);
		} else if (tag.equalsIgnoreCase("tag70")) {
			this.setTag70(val);
		} else if (tag.equalsIgnoreCase("tag71")) {
			this.setTag71(val);
		} else if (tag.equalsIgnoreCase("tag72")) {
			this.setTag72(val);
		} else if (tag.equalsIgnoreCase("tag73")) {
			this.setTag73(val);
		} else if (tag.equalsIgnoreCase("tag74")) {
			this.setTag74(val);
		} else if (tag.equalsIgnoreCase("tag75")) {
			this.setTag75(val);
		} else if (tag.equalsIgnoreCase("tag76")) {
			this.setTag76(val);
		} else if (tag.equalsIgnoreCase("tag77")) {
			this.setTag77(val);
		} else if (tag.equalsIgnoreCase("tag78")) {
			this.setTag78(val);
		} else if (tag.equalsIgnoreCase("tag79")) {
			this.setTag79(val);
		} else if (tag.equalsIgnoreCase("tag80")) {
			this.setTag80(val);
		} else if (tag.equalsIgnoreCase("tag81")) {
			this.setTag81(val);
		} else if (tag.equalsIgnoreCase("tag82")) {
			this.setTag82(val);
		} else if (tag.equalsIgnoreCase("tag83")) {
			this.setTag83(val);
		} else if (tag.equalsIgnoreCase("tag84")) {
			this.setTag84(val);
		} else if (tag.equalsIgnoreCase("tag85")) {
			this.setTag85(val);
		} else if (tag.equalsIgnoreCase("tag86")) {
			this.setTag86(val);
		} else if (tag.equalsIgnoreCase("tag87")) {
			this.setTag87(val);
		} else if (tag.equalsIgnoreCase("tag88")) {
			this.setTag88(val);
		} else if (tag.equalsIgnoreCase("tag89")) {
			this.setTag89(val);
		} else if (tag.equalsIgnoreCase("tag90")) {
			this.setTag90(val);
		} else if (tag.equalsIgnoreCase("tag91")) {
			this.setTag91(val);
		} else if (tag.equalsIgnoreCase("tag92")) {
			this.setTag92(val);
		} else if (tag.equalsIgnoreCase("tag93")) {
			this.setTag93(val);
		} else if (tag.equalsIgnoreCase("tag94")) {
			this.setTag94(val);
		} else if (tag.equalsIgnoreCase("tag95")) {
			this.setTag95(val);
		} else if (tag.equalsIgnoreCase("tag96")) {
			this.setTag96(val);
		} else if (tag.equalsIgnoreCase("tag97")) {
			this.setTag97(val);
		} else if (tag.equalsIgnoreCase("tag98")) {
			this.setTag98(val);
		} else if (tag.equalsIgnoreCase("tag99")) {
			this.setTag99(val);
		} else if (tag.equalsIgnoreCase("tag100")) {
			this.setTag100(val);
		} else if (tag.equalsIgnoreCase("tag101")) {
			this.setTag101(val);
		} else if (tag.equalsIgnoreCase("tag102")) {
			this.setTag102(val);
		} else if (tag.equalsIgnoreCase("tag103")) {
			this.setTag103(val);
		} else if (tag.equalsIgnoreCase("tag104")) {
			this.setTag104(val);
		} else if (tag.equalsIgnoreCase("tag105")) {
			this.setTag105(val);
		} else if (tag.equalsIgnoreCase("tag106")) {
			this.setTag106(val);
		} else if (tag.equalsIgnoreCase("tag107")) {
			this.setTag107(val);
		} else if (tag.equalsIgnoreCase("tag108")) {
			this.setTag108(val);
		} else if (tag.equalsIgnoreCase("tag109")) {
			this.setTag109(val);
		} else if (tag.equalsIgnoreCase("tag110")) {
			this.setTag110(val);
		} else if (tag.equalsIgnoreCase("tag111")) {
			this.setTag111(val);
		} else if (tag.equalsIgnoreCase("tag112")) {
			this.setTag112(val);
		} else if (tag.equalsIgnoreCase("tag113")) {
			this.setTag113(val);
		} else if (tag.equalsIgnoreCase("tag114")) {
			this.setTag114(val);
		} else if (tag.equalsIgnoreCase("tag115")) {
			this.setTag115(val);
		} else if (tag.equalsIgnoreCase("tag116")) {
			this.setTag116(val);
		} else if (tag.equalsIgnoreCase("tag117")) {
			this.setTag117(val);
		} else if (tag.equalsIgnoreCase("tag118")) {
			this.setTag118(val);
		} else if (tag.equalsIgnoreCase("tag119")) {
			this.setTag119(val);
		} else if (tag.equalsIgnoreCase("tag120")) {
			this.setTag120(val);
		} else if (tag.equalsIgnoreCase("tag121")) {
			this.setTag121(val);
		} else if (tag.equalsIgnoreCase("tag122")) {
			this.setTag122(val);
		} else if (tag.equalsIgnoreCase("tag123")) {
			this.setTag123(val);
		} else if (tag.equalsIgnoreCase("tag124")) {
			this.setTag124(val);
		} else if (tag.equalsIgnoreCase("tag125")) {
			this.setTag125(val);
		} else if (tag.equalsIgnoreCase("tag126")) {
			this.setTag126(val);
		} else if (tag.equalsIgnoreCase("tag127")) {
			this.setTag127(val);
		} else if (tag.equalsIgnoreCase("tag128")) {
			this.setTag128(val);
		} else if (tag.equalsIgnoreCase("tag129")) {
			this.setTag129(val);
		} else if (tag.equalsIgnoreCase("tag130")) {
			this.setTag130(val);
		} else if (tag.equalsIgnoreCase("tag131")) {
			this.setTag131(val);
		} else if (tag.equalsIgnoreCase("tag132")) {
			this.setTag132(val);
		} else if (tag.equalsIgnoreCase("tag133")) {
			this.setTag133(val);
		} else if (tag.equalsIgnoreCase("tag134")) {
			this.setTag134(val);
		} else if (tag.equalsIgnoreCase("tag135")) {
			this.setTag135(val);
		} else if (tag.equalsIgnoreCase("tag136")) {
			this.setTag136(val);
		} else if (tag.equalsIgnoreCase("tag137")) {
			this.setTag137(val);
		} else if (tag.equalsIgnoreCase("tag138")) {
			this.setTag138(val);
		} else if (tag.equalsIgnoreCase("tag139")) {
			this.setTag139(val);
		} else if (tag.equalsIgnoreCase("tag140")) {
			this.setTag140(val);
		} else if (tag.equalsIgnoreCase("tag141")) {
			this.setTag141(val);
		} else if (tag.equalsIgnoreCase("tag142")) {
			this.setTag142(val);
		} else if (tag.equalsIgnoreCase("tag143")) {
			this.setTag143(val);
		} else if (tag.equalsIgnoreCase("tag144")) {
			this.setTag144(val);
		} else if (tag.equalsIgnoreCase("tag145")) {
			this.setTag145(val);
		} else if (tag.equalsIgnoreCase("tag146")) {
			this.setTag146(val);
		} else if (tag.equalsIgnoreCase("tag147")) {
			this.setTag147(val);
		} else if (tag.equalsIgnoreCase("tag148")) {
			this.setTag148(val);
		} else if (tag.equalsIgnoreCase("tag149")) {
			this.setTag149(val);
		} else if (tag.equalsIgnoreCase("tag150")) {
			this.setTag150(val);
		} else if (tag.equalsIgnoreCase("tag151")) {
			this.setTag151(val);
		} else if (tag.equalsIgnoreCase("tag152")) {
			this.setTag152(val);
		} else if (tag.equalsIgnoreCase("tag153")) {
			this.setTag153(val);
		} else if (tag.equalsIgnoreCase("tag154")) {
			this.setTag154(val);
		} else if (tag.equalsIgnoreCase("tag155")) {
			this.setTag155(val);
		} else if (tag.equalsIgnoreCase("tag156")) {
			this.setTag156(val);
		} else if (tag.equalsIgnoreCase("tag157")) {
			this.setTag157(val);
		} else if (tag.equalsIgnoreCase("tag158")) {
			this.setTag158(val);
		} else if (tag.equalsIgnoreCase("tag159")) {
			this.setTag159(val);
		} else if (tag.equalsIgnoreCase("tag160")) {
			this.setTag160(val);
		} else if (tag.equalsIgnoreCase("tag161")) {
			this.setTag161(val);
		} else if (tag.equalsIgnoreCase("tag162")) {
			this.setTag162(val);
		} else if (tag.equalsIgnoreCase("tag163")) {
			this.setTag163(val);
		} else if (tag.equalsIgnoreCase("tag164")) {
			this.setTag164(val);
		} else if (tag.equalsIgnoreCase("tag165")) {
			this.setTag165(val);
		} else if (tag.equalsIgnoreCase("tag166")) {
			this.setTag166(val);
		} else if (tag.equalsIgnoreCase("tag167")) {
			this.setTag167(val);
		} else if (tag.equalsIgnoreCase("tag168")) {
			this.setTag168(val);
		} else if (tag.equalsIgnoreCase("tag169")) {
			this.setTag169(val);
		} else if (tag.equalsIgnoreCase("tag170")) {
			this.setTag170(val);
		} else if (tag.equalsIgnoreCase("tag171")) {
			this.setTag171(val);
		} else if (tag.equalsIgnoreCase("tag172")) {
			this.setTag172(val);
		} else if (tag.equalsIgnoreCase("tag173")) {
			this.setTag173(val);
		} else if (tag.equalsIgnoreCase("tag174")) {
			this.setTag174(val);
		} else if (tag.equalsIgnoreCase("tag175")) {
			this.setTag175(val);
		} else if (tag.equalsIgnoreCase("tag176")) {
			this.setTag176(val);
		} else if (tag.equalsIgnoreCase("tag177")) {
			this.setTag177(val);
		} else if (tag.equalsIgnoreCase("tag178")) {
			this.setTag178(val);
		} else if (tag.equalsIgnoreCase("tag179")) {
			this.setTag179(val);
		} else if (tag.equalsIgnoreCase("tag180")) {
			this.setTag180(val);
		} else if (tag.equalsIgnoreCase("tag181")) {
			this.setTag181(val);
		} else if (tag.equalsIgnoreCase("tag182")) {
			this.setTag182(val);
		} else if (tag.equalsIgnoreCase("tag183")) {
			this.setTag183(val);
		} else if (tag.equalsIgnoreCase("tag184")) {
			this.setTag184(val);
		} else if (tag.equalsIgnoreCase("tag185")) {
			this.setTag185(val);
		} else if (tag.equalsIgnoreCase("tag186")) {
			this.setTag186(val);
		} else if (tag.equalsIgnoreCase("tag187")) {
			this.setTag187(val);
		} else if (tag.equalsIgnoreCase("tag188")) {
			this.setTag188(val);
		} else if (tag.equalsIgnoreCase("tag189")) {
			this.setTag189(val);
		} else if (tag.equalsIgnoreCase("tag190")) {
			this.setTag190(val);
		} else if (tag.equalsIgnoreCase("tag191")) {
			this.setTag191(val);
		} else if (tag.equalsIgnoreCase("tag192")) {
			this.setTag192(val);
		} else if (tag.equalsIgnoreCase("tag193")) {
			this.setTag193(val);
		} else if (tag.equalsIgnoreCase("tag194")) {
			this.setTag194(val);
		} else if (tag.equalsIgnoreCase("tag195")) {
			this.setTag195(val);
		} else if (tag.equalsIgnoreCase("tag196")) {
			this.setTag196(val);
		} else if (tag.equalsIgnoreCase("tag197")) {
			this.setTag197(val);
		} else if (tag.equalsIgnoreCase("tag198")) {
			this.setTag198(val);
		} else if (tag.equalsIgnoreCase("tag199")) {
			this.setTag199(val);
		} else if (tag.equalsIgnoreCase("tag200")) {
			this.setTag200(val);
		} else if (tag.equalsIgnoreCase("tag201")) {
			this.setTag201(val);
		} else if (tag.equalsIgnoreCase("tag202")) {
			this.setTag202(val);
		} else if (tag.equalsIgnoreCase("tag203")) {
			this.setTag203(val);
		} else if (tag.equalsIgnoreCase("tag204")) {
			this.setTag204(val);
		} else if (tag.equalsIgnoreCase("tag205")) {
			this.setTag205(val);
		}
        else if (tag.equalsIgnoreCase("tag206")) {this.setTag206(val);}
        else if (tag.equalsIgnoreCase("tag207")) {this.setTag207(val);}
        else if (tag.equalsIgnoreCase("tag208")) {this.setTag208(val);}
        else if (tag.equalsIgnoreCase("tag209")) {this.setTag209(val);}
        else if (tag.equalsIgnoreCase("tag210")) {this.setTag210(val);}
        else if (tag.equalsIgnoreCase("tag211")) {this.setTag211(val);}
        else if (tag.equalsIgnoreCase("tag212")) {this.setTag212(val);}
        else if (tag.equalsIgnoreCase("tag213")) {this.setTag213(val);}
        else if (tag.equalsIgnoreCase("tag214")) {this.setTag214(val);}
        else if (tag.equalsIgnoreCase("tag215")) {this.setTag215(val);}
        else if (tag.equalsIgnoreCase("tag216")) {this.setTag216(val);}
        else if (tag.equalsIgnoreCase("tag217")) {this.setTag217(val);}
        else if (tag.equalsIgnoreCase("tag218")) {this.setTag218(val);}
        else if (tag.equalsIgnoreCase("tag219")) {this.setTag219(val);}
        else if (tag.equalsIgnoreCase("tag220")) {this.setTag220(val);}
        else if (tag.equalsIgnoreCase("tag221")) {this.setTag221(val);}
        else if (tag.equalsIgnoreCase("tag222")) {this.setTag222(val);}
        else if (tag.equalsIgnoreCase("tag223")) {this.setTag223(val);}
        else if (tag.equalsIgnoreCase("tag224")) {this.setTag224(val);}
        else if (tag.equalsIgnoreCase("tag225")) {this.setTag225(val);}
        else if (tag.equalsIgnoreCase("tag226")) {this.setTag226(val);}
        else if (tag.equalsIgnoreCase("tag227")) {this.setTag227(val);}
        else if (tag.equalsIgnoreCase("tag228")) {this.setTag228(val);}
        else if (tag.equalsIgnoreCase("tag229")) {this.setTag229(val);}
        else if (tag.equalsIgnoreCase("tag230")) {this.setTag230(val);}
        else if (tag.equalsIgnoreCase("tag231")) {this.setTag231(val);}
        else if (tag.equalsIgnoreCase("tag232")) {this.setTag232(val);}
        else if (tag.equalsIgnoreCase("tag233")) {this.setTag233(val);}
        else if (tag.equalsIgnoreCase("tag234")) {this.setTag234(val);}
        else if (tag.equalsIgnoreCase("tag235")) {this.setTag235(val);}
        else if (tag.equalsIgnoreCase("tag236")) {this.setTag236(val);}
        else if (tag.equalsIgnoreCase("tag237")) {this.setTag237(val);}
        else if (tag.equalsIgnoreCase("tag238")) {this.setTag238(val);}
        else if (tag.equalsIgnoreCase("tag239")) {this.setTag239(val);}
        else if (tag.equalsIgnoreCase("tag240")) {this.setTag240(val);}
        else if (tag.equalsIgnoreCase("tag241")) {this.setTag241(val);}
        else if (tag.equalsIgnoreCase("tag242")) {this.setTag242(val);}
        else if (tag.equalsIgnoreCase("tag243")) {this.setTag243(val);}
        else if (tag.equalsIgnoreCase("tag244")) {this.setTag244(val);}
        else if (tag.equalsIgnoreCase("tag245")) {this.setTag245(val);}
        else if (tag.equalsIgnoreCase("tag246")) {this.setTag246(val);}
        else if (tag.equalsIgnoreCase("tag247")) {this.setTag247(val);}
        else if (tag.equalsIgnoreCase("tag248")) {this.setTag248(val);}
        else if (tag.equalsIgnoreCase("tag249")) {this.setTag249(val);}
        else if (tag.equalsIgnoreCase("tag250")) {this.setTag250(val);}
        else if (tag.equalsIgnoreCase("tag251")) {this.setTag251(val);}
        else if (tag.equalsIgnoreCase("tag252")) {this.setTag252(val);}
        else if (tag.equalsIgnoreCase("tag253")) {this.setTag253(val);}
        else if (tag.equalsIgnoreCase("tag254")) {this.setTag254(val);}
        else if (tag.equalsIgnoreCase("tag255")) {this.setTag255(val);}
        else if (tag.equalsIgnoreCase("tag256")) {this.setTag256(val);}
        else if (tag.equalsIgnoreCase("tag257")) {this.setTag257(val);}
        else if (tag.equalsIgnoreCase("tag258")) {this.setTag258(val);}
        else if (tag.equalsIgnoreCase("tag259")) {this.setTag259(val);}
        else if (tag.equalsIgnoreCase("tag260")) {this.setTag260(val);}
        else if (tag.equalsIgnoreCase("tag261")) {this.setTag261(val);}
        else if (tag.equalsIgnoreCase("tag262")) {this.setTag262(val);}
        else if (tag.equalsIgnoreCase("tag263")) {this.setTag263(val);}
        else if (tag.equalsIgnoreCase("tag264")) {this.setTag264(val);}
        else if (tag.equalsIgnoreCase("tag265")) {this.setTag265(val);}
        else if (tag.equalsIgnoreCase("tag266")) {this.setTag266(val);}
        else if (tag.equalsIgnoreCase("tag267")) {this.setTag267(val);}
        else if (tag.equalsIgnoreCase("tag268")) {this.setTag268(val);}
        else if (tag.equalsIgnoreCase("tag269")) {this.setTag269(val);}
        else if (tag.equalsIgnoreCase("tag270")) {this.setTag270(val);}
        else if (tag.equalsIgnoreCase("tag271")) {this.setTag271(val);}
        else if (tag.equalsIgnoreCase("tag272")) {this.setTag272(val);}
        else if (tag.equalsIgnoreCase("tag273")) {this.setTag273(val);}
        else if (tag.equalsIgnoreCase("tag274")) {this.setTag274(val);}
        else if (tag.equalsIgnoreCase("tag275")) {this.setTag275(val);}
        else if (tag.equalsIgnoreCase("tag276")) {this.setTag276(val);}
        else if (tag.equalsIgnoreCase("tag277")) {this.setTag277(val);}
        else if (tag.equalsIgnoreCase("tag278")) {this.setTag278(val);}
        else if (tag.equalsIgnoreCase("tag279")) {this.setTag279(val);}
        else if (tag.equalsIgnoreCase("tag280")) {this.setTag280(val);}
        else if (tag.equalsIgnoreCase("tag281")) {this.setTag281(val);}
        else if (tag.equalsIgnoreCase("tag282")) {this.setTag282(val);}
        else if (tag.equalsIgnoreCase("tag283")) {this.setTag283(val);}
        else if (tag.equalsIgnoreCase("tag284")) {this.setTag284(val);}
        else if (tag.equalsIgnoreCase("tag285")) {this.setTag285(val);}
        else if (tag.equalsIgnoreCase("tag286")) {this.setTag286(val);}
        else if (tag.equalsIgnoreCase("tag287")) {this.setTag287(val);}
        else if (tag.equalsIgnoreCase("tag288")) {this.setTag288(val);}
        else if (tag.equalsIgnoreCase("tag289")) {this.setTag289(val);}
        else if (tag.equalsIgnoreCase("tag290")) {this.setTag290(val);}
        else if (tag.equalsIgnoreCase("tag291")) {this.setTag291(val);}
        else if (tag.equalsIgnoreCase("tag292")) {this.setTag292(val);}
        else if (tag.equalsIgnoreCase("tag293")) {this.setTag293(val);}
        else if (tag.equalsIgnoreCase("tag294")) {this.setTag294(val);}
        else if (tag.equalsIgnoreCase("tag295")) {this.setTag295(val);}
        else if (tag.equalsIgnoreCase("tag296")) {this.setTag296(val);}
        else if (tag.equalsIgnoreCase("tag297")) {this.setTag297(val);}
        else if (tag.equalsIgnoreCase("tag298")) {this.setTag298(val);}
        else if (tag.equalsIgnoreCase("tag299")) {this.setTag299(val);}
        else if (tag.equalsIgnoreCase("tag300")) {this.setTag300(val);}
        else if (tag.equalsIgnoreCase("tag301")) {this.setTag301(val);}
        else if (tag.equalsIgnoreCase("tag302")) {this.setTag302(val);}
        else if (tag.equalsIgnoreCase("tag303")) {this.setTag303(val);}
        else if (tag.equalsIgnoreCase("tag304")) {this.setTag304(val);}
        else if (tag.equalsIgnoreCase("tag305")) {this.setTag305(val);}
        else if (tag.equalsIgnoreCase("tag306")) {this.setTag306(val);}
        else if (tag.equalsIgnoreCase("tag307")) {this.setTag307(val);}
        else if (tag.equalsIgnoreCase("tag308")) {this.setTag308(val);}
        else if (tag.equalsIgnoreCase("tag309")) {this.setTag309(val);}
        else if (tag.equalsIgnoreCase("tag310")) {this.setTag310(val);}
        else if (tag.equalsIgnoreCase("tag311")) {this.setTag311(val);}
        else if (tag.equalsIgnoreCase("tag312")) {this.setTag312(val);}
        else if (tag.equalsIgnoreCase("tag313")) {this.setTag313(val);}
        else if (tag.equalsIgnoreCase("tag314")) {this.setTag314(val);}
        else if (tag.equalsIgnoreCase("tag315")) {this.setTag315(val);}
        else if (tag.equalsIgnoreCase("tag316")) {this.setTag316(val);}
        else if (tag.equalsIgnoreCase("tag317")) {this.setTag317(val);}
        else if (tag.equalsIgnoreCase("tag318")) {this.setTag318(val);}
        else if (tag.equalsIgnoreCase("tag319")) {this.setTag319(val);}
        else if (tag.equalsIgnoreCase("tag320")) {this.setTag320(val);}
        else if (tag.equalsIgnoreCase("tag321")) {this.setTag321(val);}
        else if (tag.equalsIgnoreCase("tag322")) {this.setTag322(val);}
        else if (tag.equalsIgnoreCase("tag323")) {this.setTag323(val);}
        else if (tag.equalsIgnoreCase("tag324")) {this.setTag324(val);}
        else if (tag.equalsIgnoreCase("tag325")) {this.setTag325(val);}
        else if (tag.equalsIgnoreCase("tag326")) {this.setTag326(val);}
        else if (tag.equalsIgnoreCase("tag327")) {this.setTag327(val);}
        else if (tag.equalsIgnoreCase("tag328")) {this.setTag328(val);}
        else if (tag.equalsIgnoreCase("tag329")) {this.setTag329(val);}
        else if (tag.equalsIgnoreCase("tag330")) {this.setTag330(val);}
        else if (tag.equalsIgnoreCase("tag331")) {this.setTag331(val);}
        else if (tag.equalsIgnoreCase("tag332")) {this.setTag332(val);}
        else if (tag.equalsIgnoreCase("tag333")) {this.setTag333(val);}
        else if (tag.equalsIgnoreCase("tag334")) {this.setTag334(val);}
        else if (tag.equalsIgnoreCase("tag335")) {this.setTag335(val);}
        else if (tag.equalsIgnoreCase("tag336")) {this.setTag336(val);}
        else if (tag.equalsIgnoreCase("tag337")) {this.setTag337(val);}
        else if (tag.equalsIgnoreCase("tag338")) {this.setTag338(val);}
        else if (tag.equalsIgnoreCase("tag339")) {this.setTag339(val);}
        else if (tag.equalsIgnoreCase("tag340")) {this.setTag340(val);}
        else if (tag.equalsIgnoreCase("tag341")) {this.setTag341(val);}
        else if (tag.equalsIgnoreCase("tag342")) {this.setTag342(val);}
        else if (tag.equalsIgnoreCase("tag343")) {this.setTag343(val);}
        else if (tag.equalsIgnoreCase("tag344")) {this.setTag344(val);}
        else if (tag.equalsIgnoreCase("tag345")) {this.setTag345(val);}
        else if (tag.equalsIgnoreCase("tag346")) {this.setTag346(val);}
        else if (tag.equalsIgnoreCase("tag347")) {this.setTag347(val);}
        else if (tag.equalsIgnoreCase("tag348")) {this.setTag348(val);}
        else if (tag.equalsIgnoreCase("tag349")) {this.setTag349(val);}
        else if (tag.equalsIgnoreCase("tag350")) {this.setTag350(val);}
        else if (tag.equalsIgnoreCase("tag351")) {this.setTag351(val);}
        else if (tag.equalsIgnoreCase("tag352")) {this.setTag352(val);}
        else if (tag.equalsIgnoreCase("tag353")) {this.setTag353(val);}
        else if (tag.equalsIgnoreCase("tag354")) {this.setTag354(val);}
        else if (tag.equalsIgnoreCase("tag355")) {this.setTag355(val);}
        else if (tag.equalsIgnoreCase("tag356")) {this.setTag356(val);}
        else if (tag.equalsIgnoreCase("tag357")) {this.setTag357(val);}
        else if (tag.equalsIgnoreCase("tag358")) {this.setTag358(val);}
        else if (tag.equalsIgnoreCase("tag359")) {this.setTag359(val);}
        else if (tag.equalsIgnoreCase("tag360")) {this.setTag360(val);}
        else if (tag.equalsIgnoreCase("tag361")) {this.setTag361(val);}
        else if (tag.equalsIgnoreCase("tag362")) {this.setTag362(val);}
        else if (tag.equalsIgnoreCase("tag363")) {this.setTag363(val);}
        else if (tag.equalsIgnoreCase("tag364")) {this.setTag364(val);}
        else if (tag.equalsIgnoreCase("tag365")) {this.setTag365(val);}
        else if (tag.equalsIgnoreCase("tag366")) {this.setTag366(val);}
        else if (tag.equalsIgnoreCase("tag367")) {this.setTag367(val);}
        else if (tag.equalsIgnoreCase("tag368")) {this.setTag368(val);}
        else if (tag.equalsIgnoreCase("tag369")) {this.setTag369(val);}
        else if (tag.equalsIgnoreCase("tag370")) {this.setTag370(val);}
        else if (tag.equalsIgnoreCase("tag371")) {this.setTag371(val);}
        else if (tag.equalsIgnoreCase("tag372")) {this.setTag372(val);}
        else if (tag.equalsIgnoreCase("tag373")) {this.setTag373(val);}
        else if (tag.equalsIgnoreCase("tag374")) {this.setTag374(val);}
        else if (tag.equalsIgnoreCase("tag375")) {this.setTag375(val);}
        else if (tag.equalsIgnoreCase("tag376")) {this.setTag376(val);}
        else if (tag.equalsIgnoreCase("tag377")) {this.setTag377(val);}
        else if (tag.equalsIgnoreCase("tag378")) {this.setTag378(val);}
        else if (tag.equalsIgnoreCase("tag379")) {this.setTag379(val);}
        else if (tag.equalsIgnoreCase("tag380")) {this.setTag380(val);}
        else if (tag.equalsIgnoreCase("tag381")) {this.setTag381(val);}
        else if (tag.equalsIgnoreCase("tag382")) {this.setTag382(val);}
        else if (tag.equalsIgnoreCase("tag383")) {this.setTag383(val);}
        else if (tag.equalsIgnoreCase("tag384")) {this.setTag384(val);}
        else if (tag.equalsIgnoreCase("tag385")) {this.setTag385(val);}
        else if (tag.equalsIgnoreCase("tag386")) {this.setTag386(val);}
        else if (tag.equalsIgnoreCase("tag387")) {this.setTag387(val);}
        else if (tag.equalsIgnoreCase("tag388")) {this.setTag388(val);}
        else if (tag.equalsIgnoreCase("tag389")) {this.setTag389(val);}
        else if (tag.equalsIgnoreCase("tag390")) {this.setTag390(val);}
        else if (tag.equalsIgnoreCase("tag391")) {this.setTag391(val);}
        else if (tag.equalsIgnoreCase("tag392")) {this.setTag392(val);}
        else if (tag.equalsIgnoreCase("tag393")) {this.setTag393(val);}
        else if (tag.equalsIgnoreCase("tag394")) {this.setTag394(val);}
        else if (tag.equalsIgnoreCase("tag395")) {this.setTag395(val);}
        else if (tag.equalsIgnoreCase("tag396")) {this.setTag396(val);}
        else if (tag.equalsIgnoreCase("tag397")) {this.setTag397(val);}
        else if (tag.equalsIgnoreCase("tag398")) {this.setTag398(val);}
        else if (tag.equalsIgnoreCase("tag399")) {this.setTag399(val);}
        else if (tag.equalsIgnoreCase("tag400")) {this.setTag400(val);}

    }

    /**
     * 读取属性值
     * @param tag 字段
     * @return
     */
    public Double getVal(String tag) {
		if (tag.equalsIgnoreCase("tag1")) {
			return this.getTag1();
		} else if (tag.equalsIgnoreCase("tag2")) {
			return this.getTag2();
		} else if (tag.equalsIgnoreCase("tag3")) {
			return this.getTag3();
		} else if (tag.equalsIgnoreCase("tag4")) {
			return this.getTag4();
		} else if (tag.equalsIgnoreCase("tag5")) {
			return this.getTag5();
		} else if (tag.equalsIgnoreCase("tag6")) {
			return this.getTag6();
		} else if (tag.equalsIgnoreCase("tag7")) {
			return this.getTag7();
		} else if (tag.equalsIgnoreCase("tag8")) {
			return this.getTag8();
		} else if (tag.equalsIgnoreCase("tag9")) {
			return this.getTag9();
		} else if (tag.equalsIgnoreCase("tag10")) {
			return this.getTag10();
		} else if (tag.equalsIgnoreCase("tag11")) {
			return this.getTag11();
		} else if (tag.equalsIgnoreCase("tag12")) {
			return this.getTag12();
		} else if (tag.equalsIgnoreCase("tag13")) {
			return this.getTag13();
		} else if (tag.equalsIgnoreCase("tag14")) {
			return this.getTag14();
		} else if (tag.equalsIgnoreCase("tag15")) {
			return this.getTag15();
		} else if (tag.equalsIgnoreCase("tag16")) {
			return this.getTag16();
		} else if (tag.equalsIgnoreCase("tag17")) {
			return this.getTag17();
		} else if (tag.equalsIgnoreCase("tag18")) {
			return this.getTag18();
		} else if (tag.equalsIgnoreCase("tag19")) {
			return this.getTag19();
		} else if (tag.equalsIgnoreCase("tag20")) {
			return this.getTag20();
		} else if (tag.equalsIgnoreCase("tag21")) {
			return this.getTag21();
		} else if (tag.equalsIgnoreCase("tag22")) {
			return this.getTag22();
		} else if (tag.equalsIgnoreCase("tag23")) {
			return this.getTag23();
		} else if (tag.equalsIgnoreCase("tag24")) {
			return this.getTag24();
		} else if (tag.equalsIgnoreCase("tag25")) {
			return this.getTag25();
		} else if (tag.equalsIgnoreCase("tag26")) {
			return this.getTag26();
		} else if (tag.equalsIgnoreCase("tag27")) {
			return this.getTag27();
		} else if (tag.equalsIgnoreCase("tag28")) {
			return this.getTag28();
		} else if (tag.equalsIgnoreCase("tag29")) {
			return this.getTag29();
		} else if (tag.equalsIgnoreCase("tag30")) {
			return this.getTag30();
		} else if (tag.equalsIgnoreCase("tag31")) {
			return this.getTag31();
		} else if (tag.equalsIgnoreCase("tag32")) {
			return this.getTag32();
		} else if (tag.equalsIgnoreCase("tag33")) {
			return this.getTag33();
		} else if (tag.equalsIgnoreCase("tag34")) {
			return this.getTag34();
		} else if (tag.equalsIgnoreCase("tag35")) {
			return this.getTag35();
		} else if (tag.equalsIgnoreCase("tag36")) {
			return this.getTag36();
		} else if (tag.equalsIgnoreCase("tag37")) {
			return this.getTag37();
		} else if (tag.equalsIgnoreCase("tag38")) {
			return this.getTag38();
		} else if (tag.equalsIgnoreCase("tag39")) {
			return this.getTag39();
		} else if (tag.equalsIgnoreCase("tag40")) {
			return this.getTag40();
		} else if (tag.equalsIgnoreCase("tag41")) {
			return this.getTag41();
		} else if (tag.equalsIgnoreCase("tag42")) {
			return this.getTag42();
		} else if (tag.equalsIgnoreCase("tag43")) {
			return this.getTag43();
		} else if (tag.equalsIgnoreCase("tag44")) {
			return this.getTag44();
		} else if (tag.equalsIgnoreCase("tag45")) {
			return this.getTag45();
		} else if (tag.equalsIgnoreCase("tag46")) {
			return this.getTag46();
		} else if (tag.equalsIgnoreCase("tag47")) {
			return this.getTag47();
		} else if (tag.equalsIgnoreCase("tag48")) {
			return this.getTag48();
		} else if (tag.equalsIgnoreCase("tag49")) {
			return this.getTag49();
		} else if (tag.equalsIgnoreCase("tag50")) {
			return this.getTag50();
		} else if (tag.equalsIgnoreCase("tag51")) {
			return this.getTag51();
		} else if (tag.equalsIgnoreCase("tag52")) {
			return this.getTag52();
		} else if (tag.equalsIgnoreCase("tag53")) {
			return this.getTag53();
		} else if (tag.equalsIgnoreCase("tag54")) {
			return this.getTag54();
		} else if (tag.equalsIgnoreCase("tag55")) {
			return this.getTag55();
		} else if (tag.equalsIgnoreCase("tag56")) {
			return this.getTag56();
		} else if (tag.equalsIgnoreCase("tag57")) {
			return this.getTag57();
		} else if (tag.equalsIgnoreCase("tag58")) {
			return this.getTag58();
		} else if (tag.equalsIgnoreCase("tag59")) {
			return this.getTag59();
		} else if (tag.equalsIgnoreCase("tag60")) {
			return this.getTag60();
		} else if (tag.equalsIgnoreCase("tag61")) {
			return this.getTag61();
		} else if (tag.equalsIgnoreCase("tag62")) {
			return this.getTag62();
		} else if (tag.equalsIgnoreCase("tag63")) {
			return this.getTag63();
		} else if (tag.equalsIgnoreCase("tag64")) {
			return this.getTag64();
		} else if (tag.equalsIgnoreCase("tag65")) {
			return this.getTag65();
		} else if (tag.equalsIgnoreCase("tag66")) {
			return this.getTag66();
		} else if (tag.equalsIgnoreCase("tag67")) {
			return this.getTag67();
		} else if (tag.equalsIgnoreCase("tag68")) {
			return this.getTag68();
		} else if (tag.equalsIgnoreCase("tag69")) {
			return this.getTag69();
		} else if (tag.equalsIgnoreCase("tag70")) {
			return this.getTag70();
		} else if (tag.equalsIgnoreCase("tag71")) {
			return this.getTag71();
		} else if (tag.equalsIgnoreCase("tag72")) {
			return this.getTag72();
		} else if (tag.equalsIgnoreCase("tag73")) {
			return this.getTag73();
		} else if (tag.equalsIgnoreCase("tag74")) {
			return this.getTag74();
		} else if (tag.equalsIgnoreCase("tag75")) {
			return this.getTag75();
		} else if (tag.equalsIgnoreCase("tag76")) {
			return this.getTag76();
		} else if (tag.equalsIgnoreCase("tag77")) {
			return this.getTag77();
		} else if (tag.equalsIgnoreCase("tag78")) {
			return this.getTag78();
		} else if (tag.equalsIgnoreCase("tag79")) {
			return this.getTag79();
		} else if (tag.equalsIgnoreCase("tag80")) {
			return this.getTag80();
		} else if (tag.equalsIgnoreCase("tag81")) {
			return this.getTag81();
		} else if (tag.equalsIgnoreCase("tag82")) {
			return this.getTag82();
		} else if (tag.equalsIgnoreCase("tag83")) {
			return this.getTag83();
		} else if (tag.equalsIgnoreCase("tag84")) {
			return this.getTag84();
		} else if (tag.equalsIgnoreCase("tag85")) {
			return this.getTag85();
		} else if (tag.equalsIgnoreCase("tag86")) {
			return this.getTag86();
		} else if (tag.equalsIgnoreCase("tag87")) {
			return this.getTag87();
		} else if (tag.equalsIgnoreCase("tag88")) {
			return this.getTag88();
		} else if (tag.equalsIgnoreCase("tag89")) {
			return this.getTag89();
		} else if (tag.equalsIgnoreCase("tag90")) {
			return this.getTag90();
		} else if (tag.equalsIgnoreCase("tag91")) {
			return this.getTag91();
		} else if (tag.equalsIgnoreCase("tag92")) {
			return this.getTag92();
		} else if (tag.equalsIgnoreCase("tag93")) {
			return this.getTag93();
		} else if (tag.equalsIgnoreCase("tag94")) {
			return this.getTag94();
		} else if (tag.equalsIgnoreCase("tag95")) {
			return this.getTag95();
		} else if (tag.equalsIgnoreCase("tag96")) {
			return this.getTag96();
		} else if (tag.equalsIgnoreCase("tag97")) {
			return this.getTag97();
		} else if (tag.equalsIgnoreCase("tag98")) {
			return this.getTag98();
		} else if (tag.equalsIgnoreCase("tag99")) {
			return this.getTag99();
		} else if (tag.equalsIgnoreCase("tag100")) {
			return this.getTag100();
		} else if (tag.equalsIgnoreCase("tag101")) {
			return this.getTag101();
		} else if (tag.equalsIgnoreCase("tag102")) {
			return this.getTag102();
		} else if (tag.equalsIgnoreCase("tag103")) {
			return this.getTag103();
		} else if (tag.equalsIgnoreCase("tag104")) {
			return this.getTag104();
		} else if (tag.equalsIgnoreCase("tag105")) {
			return this.getTag105();
		} else if (tag.equalsIgnoreCase("tag106")) {
			return this.getTag106();
		} else if (tag.equalsIgnoreCase("tag107")) {
			return this.getTag107();
		} else if (tag.equalsIgnoreCase("tag108")) {
			return this.getTag108();
		} else if (tag.equalsIgnoreCase("tag109")) {
			return this.getTag109();
		} else if (tag.equalsIgnoreCase("tag110")) {
			return this.getTag110();
		} else if (tag.equalsIgnoreCase("tag111")) {
			return this.getTag111();
		} else if (tag.equalsIgnoreCase("tag112")) {
			return this.getTag112();
		} else if (tag.equalsIgnoreCase("tag113")) {
			return this.getTag113();
		} else if (tag.equalsIgnoreCase("tag114")) {
			return this.getTag114();
		} else if (tag.equalsIgnoreCase("tag115")) {
			return this.getTag115();
		} else if (tag.equalsIgnoreCase("tag116")) {
			return this.getTag116();
		} else if (tag.equalsIgnoreCase("tag117")) {
			return this.getTag117();
		} else if (tag.equalsIgnoreCase("tag118")) {
			return this.getTag118();
		} else if (tag.equalsIgnoreCase("tag119")) {
			return this.getTag119();
		} else if (tag.equalsIgnoreCase("tag120")) {
			return this.getTag120();
		} else if (tag.equalsIgnoreCase("tag121")) {
			return this.getTag121();
		} else if (tag.equalsIgnoreCase("tag122")) {
			return this.getTag122();
		} else if (tag.equalsIgnoreCase("tag123")) {
			return this.getTag123();
		} else if (tag.equalsIgnoreCase("tag124")) {
			return this.getTag124();
		} else if (tag.equalsIgnoreCase("tag125")) {
			return this.getTag125();
		} else if (tag.equalsIgnoreCase("tag126")) {
			return this.getTag126();
		} else if (tag.equalsIgnoreCase("tag127")) {
			return this.getTag127();
		} else if (tag.equalsIgnoreCase("tag128")) {
			return this.getTag128();
		} else if (tag.equalsIgnoreCase("tag129")) {
			return this.getTag129();
		} else if (tag.equalsIgnoreCase("tag130")) {
			return this.getTag130();
		} else if (tag.equalsIgnoreCase("tag131")) {
			return this.getTag131();
		} else if (tag.equalsIgnoreCase("tag132")) {
			return this.getTag132();
		} else if (tag.equalsIgnoreCase("tag133")) {
			return this.getTag133();
		} else if (tag.equalsIgnoreCase("tag134")) {
			return this.getTag134();
		} else if (tag.equalsIgnoreCase("tag135")) {
			return this.getTag135();
		} else if (tag.equalsIgnoreCase("tag136")) {
			return this.getTag136();
		} else if (tag.equalsIgnoreCase("tag137")) {
			return this.getTag137();
		} else if (tag.equalsIgnoreCase("tag138")) {
			return this.getTag138();
		} else if (tag.equalsIgnoreCase("tag139")) {
			return this.getTag139();
		} else if (tag.equalsIgnoreCase("tag140")) {
			return this.getTag140();
		} else if (tag.equalsIgnoreCase("tag141")) {
			return this.getTag141();
		} else if (tag.equalsIgnoreCase("tag142")) {
			return this.getTag142();
		} else if (tag.equalsIgnoreCase("tag143")) {
			return this.getTag143();
		} else if (tag.equalsIgnoreCase("tag144")) {
			return this.getTag144();
		} else if (tag.equalsIgnoreCase("tag145")) {
			return this.getTag145();
		} else if (tag.equalsIgnoreCase("tag146")) {
			return this.getTag146();
		} else if (tag.equalsIgnoreCase("tag147")) {
			return this.getTag147();
		} else if (tag.equalsIgnoreCase("tag148")) {
			return this.getTag148();
		} else if (tag.equalsIgnoreCase("tag149")) {
			return this.getTag149();
		} else if (tag.equalsIgnoreCase("tag150")) {
			return this.getTag150();
		} else if (tag.equalsIgnoreCase("tag151")) {
			return this.getTag151();
		} else if (tag.equalsIgnoreCase("tag152")) {
			return this.getTag152();
		} else if (tag.equalsIgnoreCase("tag153")) {
			return this.getTag153();
		} else if (tag.equalsIgnoreCase("tag154")) {
			return this.getTag154();
		} else if (tag.equalsIgnoreCase("tag155")) {
			return this.getTag155();
		} else if (tag.equalsIgnoreCase("tag156")) {
			return this.getTag156();
		} else if (tag.equalsIgnoreCase("tag157")) {
			return this.getTag157();
		} else if (tag.equalsIgnoreCase("tag158")) {
			return this.getTag158();
		} else if (tag.equalsIgnoreCase("tag159")) {
			return this.getTag159();
		} else if (tag.equalsIgnoreCase("tag160")) {
			return this.getTag160();
		} else if (tag.equalsIgnoreCase("tag161")) {
			return this.getTag161();
		} else if (tag.equalsIgnoreCase("tag162")) {
			return this.getTag162();
		} else if (tag.equalsIgnoreCase("tag163")) {
			return this.getTag163();
		} else if (tag.equalsIgnoreCase("tag164")) {
			return this.getTag164();
		} else if (tag.equalsIgnoreCase("tag165")) {
			return this.getTag165();
		} else if (tag.equalsIgnoreCase("tag166")) {
			return this.getTag166();
		} else if (tag.equalsIgnoreCase("tag167")) {
			return this.getTag167();
		} else if (tag.equalsIgnoreCase("tag168")) {
			return this.getTag168();
		} else if (tag.equalsIgnoreCase("tag169")) {
			return this.getTag169();
		} else if (tag.equalsIgnoreCase("tag170")) {
			return this.getTag170();
		} else if (tag.equalsIgnoreCase("tag171")) {
			return this.getTag171();
		} else if (tag.equalsIgnoreCase("tag172")) {
			return this.getTag172();
		} else if (tag.equalsIgnoreCase("tag173")) {
			return this.getTag173();
		} else if (tag.equalsIgnoreCase("tag174")) {
			return this.getTag174();
		} else if (tag.equalsIgnoreCase("tag175")) {
			return this.getTag175();
		} else if (tag.equalsIgnoreCase("tag176")) {
			return this.getTag176();
		} else if (tag.equalsIgnoreCase("tag177")) {
			return this.getTag177();
		} else if (tag.equalsIgnoreCase("tag178")) {
			return this.getTag178();
		} else if (tag.equalsIgnoreCase("tag179")) {
			return this.getTag179();
		} else if (tag.equalsIgnoreCase("tag180")) {
			return this.getTag180();
		} else if (tag.equalsIgnoreCase("tag181")) {
			return this.getTag181();
		} else if (tag.equalsIgnoreCase("tag182")) {
			return this.getTag182();
		} else if (tag.equalsIgnoreCase("tag183")) {
			return this.getTag183();
		} else if (tag.equalsIgnoreCase("tag184")) {
			return this.getTag184();
		} else if (tag.equalsIgnoreCase("tag185")) {
			return this.getTag185();
		} else if (tag.equalsIgnoreCase("tag186")) {
			return this.getTag186();
		} else if (tag.equalsIgnoreCase("tag187")) {
			return this.getTag187();
		} else if (tag.equalsIgnoreCase("tag188")) {
			return this.getTag188();
		} else if (tag.equalsIgnoreCase("tag189")) {
			return this.getTag189();
		} else if (tag.equalsIgnoreCase("tag190")) {
			return this.getTag190();
		} else if (tag.equalsIgnoreCase("tag191")) {
			return this.getTag191();
		} else if (tag.equalsIgnoreCase("tag192")) {
			return this.getTag192();
		} else if (tag.equalsIgnoreCase("tag193")) {
			return this.getTag193();
		} else if (tag.equalsIgnoreCase("tag194")) {
			return this.getTag194();
		} else if (tag.equalsIgnoreCase("tag195")) {
			return this.getTag195();
		} else if (tag.equalsIgnoreCase("tag196")) {
			return this.getTag196();
		} else if (tag.equalsIgnoreCase("tag197")) {
			return this.getTag197();
		} else if (tag.equalsIgnoreCase("tag198")) {
			return this.getTag198();
		} else if (tag.equalsIgnoreCase("tag199")) {
			return this.getTag199();
		} else if (tag.equalsIgnoreCase("tag200")) {
			return this.getTag200();
		} else if (tag.equalsIgnoreCase("tag201")) {
			return this.getTag201();
		} else if (tag.equalsIgnoreCase("tag202")) {
			return this.getTag202();
		} else if (tag.equalsIgnoreCase("tag203")) {
			return this.getTag203();
		} else if (tag.equalsIgnoreCase("tag204")) {
			return this.getTag204();
		} else if (tag.equalsIgnoreCase("tag205")) {
			return this.getTag205();
		} else if (tag.equalsIgnoreCase("tag206")) {return this.getTag206();}
        else if (tag.equalsIgnoreCase("tag207")) {return this.getTag207();}
        else if (tag.equalsIgnoreCase("tag208")) {return this.getTag208();}
        else if (tag.equalsIgnoreCase("tag209")) {return this.getTag209();}
        else if (tag.equalsIgnoreCase("tag210")) {return this.getTag210();}
        else if (tag.equalsIgnoreCase("tag211")) {return this.getTag211();}
        else if (tag.equalsIgnoreCase("tag212")) {return this.getTag212();}
        else if (tag.equalsIgnoreCase("tag213")) {return this.getTag213();}
        else if (tag.equalsIgnoreCase("tag214")) {return this.getTag214();}
        else if (tag.equalsIgnoreCase("tag215")) {return this.getTag215();}
        else if (tag.equalsIgnoreCase("tag216")) {return this.getTag216();}
        else if (tag.equalsIgnoreCase("tag217")) {return this.getTag217();}
        else if (tag.equalsIgnoreCase("tag218")) {return this.getTag218();}
        else if (tag.equalsIgnoreCase("tag219")) {return this.getTag219();}
        else if (tag.equalsIgnoreCase("tag220")) {return this.getTag220();}
        else if (tag.equalsIgnoreCase("tag221")) {return this.getTag221();}
        else if (tag.equalsIgnoreCase("tag222")) {return this.getTag222();}
        else if (tag.equalsIgnoreCase("tag223")) {return this.getTag223();}
        else if (tag.equalsIgnoreCase("tag224")) {return this.getTag224();}
        else if (tag.equalsIgnoreCase("tag225")) {return this.getTag225();}
        else if (tag.equalsIgnoreCase("tag226")) {return this.getTag226();}
        else if (tag.equalsIgnoreCase("tag227")) {return this.getTag227();}
        else if (tag.equalsIgnoreCase("tag228")) {return this.getTag228();}
        else if (tag.equalsIgnoreCase("tag229")) {return this.getTag229();}
        else if (tag.equalsIgnoreCase("tag230")) {return this.getTag230();}
        else if (tag.equalsIgnoreCase("tag231")) {return this.getTag231();}
        else if (tag.equalsIgnoreCase("tag232")) {return this.getTag232();}
        else if (tag.equalsIgnoreCase("tag233")) {return this.getTag233();}
        else if (tag.equalsIgnoreCase("tag234")) {return this.getTag234();}
        else if (tag.equalsIgnoreCase("tag235")) {return this.getTag235();}
        else if (tag.equalsIgnoreCase("tag236")) {return this.getTag236();}
        else if (tag.equalsIgnoreCase("tag237")) {return this.getTag237();}
        else if (tag.equalsIgnoreCase("tag238")) {return this.getTag238();}
        else if (tag.equalsIgnoreCase("tag239")) {return this.getTag239();}
        else if (tag.equalsIgnoreCase("tag240")) {return this.getTag240();}
        else if (tag.equalsIgnoreCase("tag241")) {return this.getTag241();}
        else if (tag.equalsIgnoreCase("tag242")) {return this.getTag242();}
        else if (tag.equalsIgnoreCase("tag243")) {return this.getTag243();}
        else if (tag.equalsIgnoreCase("tag244")) {return this.getTag244();}
        else if (tag.equalsIgnoreCase("tag245")) {return this.getTag245();}
        else if (tag.equalsIgnoreCase("tag246")) {return this.getTag246();}
        else if (tag.equalsIgnoreCase("tag247")) {return this.getTag247();}
        else if (tag.equalsIgnoreCase("tag248")) {return this.getTag248();}
        else if (tag.equalsIgnoreCase("tag249")) {return this.getTag249();}
        else if (tag.equalsIgnoreCase("tag250")) {return this.getTag250();}
        else if (tag.equalsIgnoreCase("tag251")) {return this.getTag251();}
        else if (tag.equalsIgnoreCase("tag252")) {return this.getTag252();}
        else if (tag.equalsIgnoreCase("tag253")) {return this.getTag253();}
        else if (tag.equalsIgnoreCase("tag254")) {return this.getTag254();}
        else if (tag.equalsIgnoreCase("tag255")) {return this.getTag255();}
        else if (tag.equalsIgnoreCase("tag256")) {return this.getTag256();}
        else if (tag.equalsIgnoreCase("tag257")) {return this.getTag257();}
        else if (tag.equalsIgnoreCase("tag258")) {return this.getTag258();}
        else if (tag.equalsIgnoreCase("tag259")) {return this.getTag259();}
        else if (tag.equalsIgnoreCase("tag260")) {return this.getTag260();}
        else if (tag.equalsIgnoreCase("tag261")) {return this.getTag261();}
        else if (tag.equalsIgnoreCase("tag262")) {return this.getTag262();}
        else if (tag.equalsIgnoreCase("tag263")) {return this.getTag263();}
        else if (tag.equalsIgnoreCase("tag264")) {return this.getTag264();}
        else if (tag.equalsIgnoreCase("tag265")) {return this.getTag265();}
        else if (tag.equalsIgnoreCase("tag266")) {return this.getTag266();}
        else if (tag.equalsIgnoreCase("tag267")) {return this.getTag267();}
        else if (tag.equalsIgnoreCase("tag268")) {return this.getTag268();}
        else if (tag.equalsIgnoreCase("tag269")) {return this.getTag269();}
        else if (tag.equalsIgnoreCase("tag270")) {return this.getTag270();}
        else if (tag.equalsIgnoreCase("tag271")) {return this.getTag271();}
        else if (tag.equalsIgnoreCase("tag272")) {return this.getTag272();}
        else if (tag.equalsIgnoreCase("tag273")) {return this.getTag273();}
        else if (tag.equalsIgnoreCase("tag274")) {return this.getTag274();}
        else if (tag.equalsIgnoreCase("tag275")) {return this.getTag275();}
        else if (tag.equalsIgnoreCase("tag276")) {return this.getTag276();}
        else if (tag.equalsIgnoreCase("tag277")) {return this.getTag277();}
        else if (tag.equalsIgnoreCase("tag278")) {return this.getTag278();}
        else if (tag.equalsIgnoreCase("tag279")) {return this.getTag279();}
        else if (tag.equalsIgnoreCase("tag280")) {return this.getTag280();}
        else if (tag.equalsIgnoreCase("tag281")) {return this.getTag281();}
        else if (tag.equalsIgnoreCase("tag282")) {return this.getTag282();}
        else if (tag.equalsIgnoreCase("tag283")) {return this.getTag283();}
        else if (tag.equalsIgnoreCase("tag284")) {return this.getTag284();}
        else if (tag.equalsIgnoreCase("tag285")) {return this.getTag285();}
        else if (tag.equalsIgnoreCase("tag286")) {return this.getTag286();}
        else if (tag.equalsIgnoreCase("tag287")) {return this.getTag287();}
        else if (tag.equalsIgnoreCase("tag288")) {return this.getTag288();}
        else if (tag.equalsIgnoreCase("tag289")) {return this.getTag289();}
        else if (tag.equalsIgnoreCase("tag290")) {return this.getTag290();}
        else if (tag.equalsIgnoreCase("tag291")) {return this.getTag291();}
        else if (tag.equalsIgnoreCase("tag292")) {return this.getTag292();}
        else if (tag.equalsIgnoreCase("tag293")) {return this.getTag293();}
        else if (tag.equalsIgnoreCase("tag294")) {return this.getTag294();}
        else if (tag.equalsIgnoreCase("tag295")) {return this.getTag295();}
        else if (tag.equalsIgnoreCase("tag296")) {return this.getTag296();}
        else if (tag.equalsIgnoreCase("tag297")) {return this.getTag297();}
        else if (tag.equalsIgnoreCase("tag298")) {return this.getTag298();}
        else if (tag.equalsIgnoreCase("tag299")) {return this.getTag299();}
        else if (tag.equalsIgnoreCase("tag300")) {return this.getTag300();}
        else if (tag.equalsIgnoreCase("tag301")) {return this.getTag301();}
        else if (tag.equalsIgnoreCase("tag302")) {return this.getTag302();}
        else if (tag.equalsIgnoreCase("tag303")) {return this.getTag303();}
        else if (tag.equalsIgnoreCase("tag304")) {return this.getTag304();}
        else if (tag.equalsIgnoreCase("tag305")) {return this.getTag305();}
        else if (tag.equalsIgnoreCase("tag306")) {return this.getTag306();}
        else if (tag.equalsIgnoreCase("tag307")) {return this.getTag307();}
        else if (tag.equalsIgnoreCase("tag308")) {return this.getTag308();}
        else if (tag.equalsIgnoreCase("tag309")) {return this.getTag309();}
        else if (tag.equalsIgnoreCase("tag310")) {return this.getTag310();}
        else if (tag.equalsIgnoreCase("tag311")) {return this.getTag311();}
        else if (tag.equalsIgnoreCase("tag312")) {return this.getTag312();}
        else if (tag.equalsIgnoreCase("tag313")) {return this.getTag313();}
        else if (tag.equalsIgnoreCase("tag314")) {return this.getTag314();}
        else if (tag.equalsIgnoreCase("tag315")) {return this.getTag315();}
        else if (tag.equalsIgnoreCase("tag316")) {return this.getTag316();}
        else if (tag.equalsIgnoreCase("tag317")) {return this.getTag317();}
        else if (tag.equalsIgnoreCase("tag318")) {return this.getTag318();}
        else if (tag.equalsIgnoreCase("tag319")) {return this.getTag319();}
        else if (tag.equalsIgnoreCase("tag320")) {return this.getTag320();}
        else if (tag.equalsIgnoreCase("tag321")) {return this.getTag321();}
        else if (tag.equalsIgnoreCase("tag322")) {return this.getTag322();}
        else if (tag.equalsIgnoreCase("tag323")) {return this.getTag323();}
        else if (tag.equalsIgnoreCase("tag324")) {return this.getTag324();}
        else if (tag.equalsIgnoreCase("tag325")) {return this.getTag325();}
        else if (tag.equalsIgnoreCase("tag326")) {return this.getTag326();}
        else if (tag.equalsIgnoreCase("tag327")) {return this.getTag327();}
        else if (tag.equalsIgnoreCase("tag328")) {return this.getTag328();}
        else if (tag.equalsIgnoreCase("tag329")) {return this.getTag329();}
        else if (tag.equalsIgnoreCase("tag330")) {return this.getTag330();}
        else if (tag.equalsIgnoreCase("tag331")) {return this.getTag331();}
        else if (tag.equalsIgnoreCase("tag332")) {return this.getTag332();}
        else if (tag.equalsIgnoreCase("tag333")) {return this.getTag333();}
        else if (tag.equalsIgnoreCase("tag334")) {return this.getTag334();}
        else if (tag.equalsIgnoreCase("tag335")) {return this.getTag335();}
        else if (tag.equalsIgnoreCase("tag336")) {return this.getTag336();}
        else if (tag.equalsIgnoreCase("tag337")) {return this.getTag337();}
        else if (tag.equalsIgnoreCase("tag338")) {return this.getTag338();}
        else if (tag.equalsIgnoreCase("tag339")) {return this.getTag339();}
        else if (tag.equalsIgnoreCase("tag340")) {return this.getTag340();}
        else if (tag.equalsIgnoreCase("tag341")) {return this.getTag341();}
        else if (tag.equalsIgnoreCase("tag342")) {return this.getTag342();}
        else if (tag.equalsIgnoreCase("tag343")) {return this.getTag343();}
        else if (tag.equalsIgnoreCase("tag344")) {return this.getTag344();}
        else if (tag.equalsIgnoreCase("tag345")) {return this.getTag345();}
        else if (tag.equalsIgnoreCase("tag346")) {return this.getTag346();}
        else if (tag.equalsIgnoreCase("tag347")) {return this.getTag347();}
        else if (tag.equalsIgnoreCase("tag348")) {return this.getTag348();}
        else if (tag.equalsIgnoreCase("tag349")) {return this.getTag349();}
        else if (tag.equalsIgnoreCase("tag350")) {return this.getTag350();}
        else if (tag.equalsIgnoreCase("tag351")) {return this.getTag351();}
        else if (tag.equalsIgnoreCase("tag352")) {return this.getTag352();}
        else if (tag.equalsIgnoreCase("tag353")) {return this.getTag353();}
        else if (tag.equalsIgnoreCase("tag354")) {return this.getTag354();}
        else if (tag.equalsIgnoreCase("tag355")) {return this.getTag355();}
        else if (tag.equalsIgnoreCase("tag356")) {return this.getTag356();}
        else if (tag.equalsIgnoreCase("tag357")) {return this.getTag357();}
        else if (tag.equalsIgnoreCase("tag358")) {return this.getTag358();}
        else if (tag.equalsIgnoreCase("tag359")) {return this.getTag359();}
        else if (tag.equalsIgnoreCase("tag360")) {return this.getTag360();}
        else if (tag.equalsIgnoreCase("tag361")) {return this.getTag361();}
        else if (tag.equalsIgnoreCase("tag362")) {return this.getTag362();}
        else if (tag.equalsIgnoreCase("tag363")) {return this.getTag363();}
        else if (tag.equalsIgnoreCase("tag364")) {return this.getTag364();}
        else if (tag.equalsIgnoreCase("tag365")) {return this.getTag365();}
        else if (tag.equalsIgnoreCase("tag366")) {return this.getTag366();}
        else if (tag.equalsIgnoreCase("tag367")) {return this.getTag367();}
        else if (tag.equalsIgnoreCase("tag368")) {return this.getTag368();}
        else if (tag.equalsIgnoreCase("tag369")) {return this.getTag369();}
        else if (tag.equalsIgnoreCase("tag370")) {return this.getTag370();}
        else if (tag.equalsIgnoreCase("tag371")) {return this.getTag371();}
        else if (tag.equalsIgnoreCase("tag372")) {return this.getTag372();}
        else if (tag.equalsIgnoreCase("tag373")) {return this.getTag373();}
        else if (tag.equalsIgnoreCase("tag374")) {return this.getTag374();}
        else if (tag.equalsIgnoreCase("tag375")) {return this.getTag375();}
        else if (tag.equalsIgnoreCase("tag376")) {return this.getTag376();}
        else if (tag.equalsIgnoreCase("tag377")) {return this.getTag377();}
        else if (tag.equalsIgnoreCase("tag378")) {return this.getTag378();}
        else if (tag.equalsIgnoreCase("tag379")) {return this.getTag379();}
        else if (tag.equalsIgnoreCase("tag380")) {return this.getTag380();}
        else if (tag.equalsIgnoreCase("tag381")) {return this.getTag381();}
        else if (tag.equalsIgnoreCase("tag382")) {return this.getTag382();}
        else if (tag.equalsIgnoreCase("tag383")) {return this.getTag383();}
        else if (tag.equalsIgnoreCase("tag384")) {return this.getTag384();}
        else if (tag.equalsIgnoreCase("tag385")) {return this.getTag385();}
        else if (tag.equalsIgnoreCase("tag386")) {return this.getTag386();}
        else if (tag.equalsIgnoreCase("tag387")) {return this.getTag387();}
        else if (tag.equalsIgnoreCase("tag388")) {return this.getTag388();}
        else if (tag.equalsIgnoreCase("tag389")) {return this.getTag389();}
        else if (tag.equalsIgnoreCase("tag390")) {return this.getTag390();}
        else if (tag.equalsIgnoreCase("tag391")) {return this.getTag391();}
        else if (tag.equalsIgnoreCase("tag392")) {return this.getTag392();}
        else if (tag.equalsIgnoreCase("tag393")) {return this.getTag393();}
        else if (tag.equalsIgnoreCase("tag394")) {return this.getTag394();}
        else if (tag.equalsIgnoreCase("tag395")) {return this.getTag395();}
        else if (tag.equalsIgnoreCase("tag396")) {return this.getTag396();}
        else if (tag.equalsIgnoreCase("tag397")) {return this.getTag397();}
        else if (tag.equalsIgnoreCase("tag398")) {return this.getTag398();}
        else if (tag.equalsIgnoreCase("tag399")) {return this.getTag399();}
        else if (tag.equalsIgnoreCase("tag400")) {return this.getTag400();}

        else {
			return null;
		}
    }
}
